##############################################################################
#
#
#   Project:   Asynchronous Action Library Project
#              http://aalib.sourceforge.net/
#
#   Author(s): Romeu A. Pieritz
#   Contact  : aalib_info@yahoo.com
#
#   Date:      2005/02/02
#
#   License:
#   --------------------------------------------------------------------------
#   Asynchronous Action Library Project
#   Copyright (c) 2005-2007, AALib-PyAALib developers (see above AUTHORS)
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#   Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
#   Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
#   Neither the names of AALib's copyright owner nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##############################################################################


from ALObject  import  ALObject
from ALString  import  ALString
from ALXmlNode import  ALXmlNode

     
class ALDict( ALObject, dict ):
    """
    Interface for AL dict objects.
    Warning: This class is NOT ordered! The elements sorting is random
    to use a ORDERED dictionary : ALDictionary
    This class will be deprecated in the future
    """
    def __init__( self ):
        ALObject.__init__( self )
        dict.__init__( self )
 
    
    def getValue( self, _key ):
        return self.get( _key )
   
   
    def setValue( self, _key, _value ):
        self[_key] = _value
    
    
    def add( self, _key, _value ):
        self[_key] = _value
  
  
    # Basic interface to generic objects
    def getObject( self, _key ):
        return self.get( _key )


    def addObject( self, _key, _value ):
        self[_key] = _value
    
    
    def getNumberObjects( self ):
        return len( self )
        
      
    def inputXml( self, _oalXmlElement, _oalXml = None  ):
        self.inputXmlObject( _oalXmlElement )
        
        for inode in _oalXmlElement.childNodes:
            if ( inode.nodeType==ALXmlNode.ELEMENT_NODE ):
                for jnode in inode.childNodes:
                    if ( jnode.nodeType==ALXmlNode.TEXT_NODE ):
                        oalToken  = ALString( inode.nodeName )
                        oalString = ALString( jnode.data )
                        if ( oalToken!="objectID" and oalToken!="objectVersion" and oalToken!="objectName" ): 
                            self.addObject( oalToken.cleanXml(), oalString.cleanXml() )  

       
    def outputXml( self, _oalXml, _oalXmlElement ):        
        oalXmlElementObject = self.outputXmlObject( _oalXml, _oalXmlElement )
        
        for ikey in self:
            if ( self[ ikey ] is not None ):         
               oalXmlElement = _oalXml.createElement( ALString( ikey ) )
               oalXmlElement.appendChild( _oalXml.createTextNode( ALString( self[ ikey ] ) ) )      
               oalXmlElementObject.appendChild( oalXmlElement )
    
    