##############################################################################
#
#
#   Project:   Asynchronous Action Library Project
#              http://aalib.sourceforge.net/
#
#   Author(s): Romeu A. Pieritz
#   Contact  : aalib_info@yahoo.com
#
#   Date:      2005/02/02
#
#   License:
#   --------------------------------------------------------------------------
#   Asynchronous Action Library Project
#   Copyright (c) 2005-2007, AALib-PyAALib developers (see above AUTHORS)
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#   Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
#   Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
#   Neither the names of AALib's copyright owner nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##############################################################################


from ALImportPython  import *
from ALStream        import ALStream
from ALList          import ALList


class ALStreamFile( ALStream ):
    """
    Class for File streams (text and binary)

    """


    def __init__( self, _oalString, _oalStringFlag = "write" ):
        ALStream.__init__( self, _oalString )
        oalStringFlag = str( _oalStringFlag )

        if ( oalStringFlag.capitalize()=="Write" ):
            oalStringFlag = "w"
        elif ( oalStringFlag.capitalize()=="Append" ):
            oalStringFlag = "a"
        elif ( oalStringFlag.capitalize()=="Read" ):
            oalStringFlag = "r"
        elif ( oalStringFlag.capitalize()=="Writebinnary" ):
            oalStringFlag = "wb"
        elif (oalStringFlag.capitalize()=="Appendbinnary" ): # duvida se funciona
            oalStringFlag = "ab"
        elif ( oalStringFlag.capitalize()=="Readbinnary" ):
            oalStringFlag = "rb"


        self.m_oalStreamFlag = oalStringFlag
        if ( self.m_oalStreamFlag != "a"  and  self.m_oalStreamFlag != "ab" ):
            self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
            self.m_bIsOpen = True;



    def write( self, _oalObject ):
        self.synchronizeOn()
        if ( self.m_oalStreamFlag=="a" ):
            self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
            self.m_oalStream.write( _oalObject )
            self.m_oalStream.close()
        elif( self.m_oalStreamFlag=="w" or self.m_oalStreamFlag=="wb" ):
            self.m_oalStream.write( _oalObject )
        self.synchronizeOff()


    def getLines( self ):
        self.synchronizeOn()
        oalList = None
        if (self.m_bIsOpen == True):
            oalList = ALList( self.m_oalStream.readlines() )
        else:
            self.m_oalStream = open( self.m_oalStreamName, "r" )
            oalList = ALList( self.m_oalStream.readlines() )
            self.m_oalStream.close()
            self.m_bIsOpen = False;
        self.synchronizeOff()
        return oalList


    def readLines( self ):
        return self.getLines()


 #   def read( self, _iBuffer = 8096 ):
    def read( self ):
        """
        Warning: must be changed for other streams like pipes and stdouts...to verify

        """
        self.synchronizeOn()
        oalObject = None
        if (self.m_bIsOpen == True):
            oalObject = self.m_oalStream.read()
        else:
            self.m_oalStream = open( self.m_oalStreamName, "r" )
            oalObject = self.m_oalStream.read()
            self.m_oalStream.close()
            self.m_bIsOpen = False;
        self.synchronizeOff()
        return oalObject


##############################################################################
