##############################################################################
#
#
#   Project:   Asynchronous Action Library Project
#              http://aalib.sourceforge.net/
#
#   Author(s): Romeu A. Pieritz
#   Contact  : aalib_info@yahoo.com
#
#   Date:      2005/02/02
#
#   License:
#   --------------------------------------------------------------------------
#   Asynchronous Action Library Project
#   Copyright (c) 2005-2007, AALib-PyAALib developers (see above AUTHORS)
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#   Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
#   Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
#   Neither the names of AALib's copyright owner nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##############################################################################


AL_FRAMEWORK_NAME   = "AsynchronousActionLibraryProject"        # FrameworkName
AL_VERSION          = "2.0"                                     # Version :2.0
AL_OBJECT_ID        = "AALibOBJID"
AL_TIME_INFINITE    = 999999.0                                  # Seconds - It is: 11d:13h:46m:39s:000ms
AL_TIME_MINIMUM     = 0.8                                       # Seconds - It is :00d:00h:00m:00s:100ms
AL_TIME_SECOND      = 1.0                                       # Seconds - It is :00d:00h:00m:01s:000ms
AL_TOKEN_SEPARATOR  = "[]-[]"

# ALApplication Framework
AL_FRAMEWORK_APPLICATION_NAME               = "AALibFrameworkApplication"
AL_FRAMEWORK_RESSOURCE_SYSTEM_NAME          = "system_resource.res"
AL_FRAMEWORK_RESSOURCE_USER_NAME            = "resource.res"
AL_FRAMEWORK_LOG_NAME                       = "AALib-run.log"
AL_FRAMEWORK_FORCE_CLOSE_APPLICATION        = "ForceCloseApplication"
AL_FRAMEWORK_LAST_RUN                       = "RALLastRun"
# AL_FRAMEWORK_FORCE_EXCEPTION              = "GHOST_IN_THE_SHELL"


# ALAction Signal
AL_ACTION_SIGNAL_PAUSED                     = "SignalActionPaused"
AL_ACTION_SIGNAL_ABORT                      = "SignalActionAbort"
AL_ACTION_SIGNAL_ERROR                      = "SignalActionError"
AL_ACTION_SIGNAL_EXCEPTION                  = "SignalActionException"
AL_ACTION_SIGNAL_EXIT                       = "SignalActionExit"


# ALSignal
AL_SIGNAL_OK                                = "SignalOK"



# ALHdf5 - EDF
AL_HDF5_EDF_LIST                            = "EdfList"
AL_HDF5_EDF_HEADER_BASIC                    = "EdfHeaderBasic"
AL_HDF5_EDF_HEADER_EXTENSION                = "EdfHeaderExtension"
AL_HDF5_EDF_DATA_SET                        = "EdfDataSet"
AL_HDF5_EDF_DATA_ARRAY                      = "EdfDataArray"
AL_HDF5_FILE_NAME                           = "FILENAME"
AL_HDF5_DIMENSIONS                          = "DIMENSIONS"
AL_HDF5_X_SIZE                              = "XSize"
AL_HDF5_Y_SIZE                              = "YSize"
AL_HDF5_Z_SIZE                              = "ZSize"
AL_HDF5_CREATOR                             = "CREATOR"
AL_HDF5_AUTHOR                              = "AUTHOR"
AL_HDF5_DATE                                = "DATE"
AL_HDF5_AALIB                               = "AALIBPROJECT"
AL_HDF5_AALIB_VERSION                       = "AALIBVERSION"



# System Dependence Definition
AL_SYSTEM_UNKNOWN     = "Warning::UnknownOS"
AL_SYSTEM_JAVA        = "JavaSystem"
AL_SYSTEM_WINDOWS     = "WindowsSystem"
AL_SYSTEM_LINUX       = "LinuxSystem"
AL_SYSTEM_BSD         = "BSDSystem"
AL_SYSTEM_SOLARIS     = "SunSystem"
AL_SYSTEM_MACOSX      = "MacOSXSystem"
AL_SYSTEM_WINCYGWIN   = "WindowsCygwinSystem"



# Some options to put in the command line of the applications
# --DEBUG                                    = To save the the raise information in the log file
# --DEBUGPLUGIN                              = To save the the raise information in the log file and the screen
# --DEBUGPYTHON                              = To use the default raise mechanism
# --DEBUGJYTHON                              = To use the default raise mechanism
# --DEBUGJAVA                                = To use the default raise mechanism
# --DEBUGECLIPSE                             = To use the default raise mechanism
# --DEBUGECLIPSEACTION                       = To use the default raise mechanism in the actions and threads
# --verbose                                  = To output on the screen the information
# --log                                      = To save the output information only in the log file
