##############################################################################
#
#
#   Project:   Asynchronous Action Library Project
#              http://aalib.sourceforge.net/
#
#   Author(s): Romeu A. Pieritz
#   Contact  : aalib_info@yahoo.com
#
#   Date:      2005/02/02
#
#   License:
#   --------------------------------------------------------------------------
#   Asynchronous Action Library Project
#   Copyright (c) 2005-2007, AALib-PyAALib developers (see above AUTHORS)
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#   Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
#   Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
#   Neither the names of AALib's copyright owner nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
##############################################################################


##############################################################################
# Importing here only Standart Python modules in the standart distribution

import  os                  as PyOS
import  sys                 as PySys
import  shutil              as PyShutil
import  copy                as PyCopy
import  random              as PyRandom
import  time                as PyTime
import  string              as PyString
import  getopt              as PyGetOpt
import  traceback           as PyTraceback
import  glob                as PyGlob
import  stat                as PyStat
import  md5                 as PyMD5
import  socket              as PySocket
import  xml.dom.minidom     as PyXml
import  xmlrpclib           as PyXmlRpcLib
import  pickle              as PySerializer
import  select              as PySelect
import  threading           as PyThreading
import  xml.dom.minidom     as PyMinidom

from    popen2              import popen3                   as PyPipe3
from    httplib             import HTTP                     as PyHTTP
from    thread              import start_new_thread         as PyStartNewThread
from    threading           import Thread                   as PyThread
from    threading           import Semaphore                as PySemaphore
from    threading           import _Condition               as PyCondition
from    BaseHTTPServer      import HTTPServer               as PyHTTPServer
from    BaseHTTPServer      import BaseHTTPRequestHandler   as PyBaseHTTPRequestHandler
from    pickle              import Pickler                  as PyPickler
from    pickle              import Unpickler                as PyUnPickler

from    xml.dom.minidom     import Document                 as PyXmlDocument
from    xml.dom.minidom     import parse                    as PyXmlParser
from    xml.dom.minidom     import parseString              as PyXmlParserString
from    xml.dom.minidom     import Node                     as PyXmlNode
from    xml.dom.minidom     import Element                  as PyXmlElement
from    xml.dom.xmlbuilder  import DOMImplementationLS      as PyDOMImplementationLS
from    SimpleXMLRPCServer  import SimpleXMLRPCServer       as PySimpleXMLRPCServer
from    xmlrpclib           import ServerProxy              as PyXmlRpcServer


##################################################################################
#Jython2.2 to Python2.n compatibility - This part is not running on JavaJython yet
oSystem = PySys.platform[:4]
if (oSystem!="java"):
    import  platform            as PyPlatform
    import  getpass             as PyGetPass
    import  subprocess          as PySubProcess
    import  signal              as PySignal
    from    distutils.text_file import TextFile   as PyTextFile




##############################################################################
#