#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDActionExecuteSystemCommand.py 474 2008-07-30 15:51:54Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport import EDAction
from EDImport import EDVerbose
from EDImport import EDManagerProcess
from EDImport import PyOs

# This class is a temporary solution for the "==>[ERROR]: OSError: [Errno 10] No child processes"
# problem with ALActionProcess (Python bug in subprocess, see bug #61)
#

class EDActionExecuteSystemCommand( EDAction ):
    
    
    def __init__( self, _oedStingCommand ):
        EDAction.__init__( self )
        self.m_oedStringCommand = _oedStingCommand
        self.m_iErrorCode = None
        self.m_oedManagerProcess = EDManagerProcess()
        
        
    def process( self, _oedPlugin ):
        EDVerbose.DEBUG( "*** EDActionExecuteSystemCommand.process" )
        self.synchronizeOn()
        self.m_iErrorCode = PyOs.system( self.m_oedStringCommand )
        self.synchronizeOff()
        
        
    def getErrorCode( self ):
        return self.m_iErrorCode


    def abort( self, _oalObject = None ):
        EDVerbose.DEBUG( "*** EDActionExecuteSystemCommand.abort" )
        self.synchronizeOn()
        self.m_oedManagerProcess.killProcess( self.m_oedStringCommand )
        self.m_bIsAbort = True
        self.synchronizeOff()
        