#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDPluginExec.py 474 2008-07-30 15:51:54Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDPlugin    import EDPlugin
from EDImport    import EDVerbose

class EDPluginExec( EDPlugin ):
    """
    Super class for all plugins who executes something.
    """
    
    def __init__ ( self ):
        """
        """
        EDPlugin.__init__( self )
        
        
    def preProcess( self, _oalObject = None ):
        """
        """
        EDPlugin.preProcess( self )
        EDVerbose.DEBUG( "*** EDPluginExec.preProcess")
        
        
    def process( self, _oalObject = None ):
        """
        """
        EDPlugin.process( self )
        EDVerbose.DEBUG( "*** EDPluginExec.process")
        

    def postProcess( self, _oalObject = None ):
        """
        """
        EDPlugin.postProcess( self )
        EDVerbose.DEBUG( "*** EDPluginExec.postProcess")
    

    def configure( self ):
        """
        """
        EDPlugin.configure( self )
        EDVerbose.DEBUG( "*** EDPluginExec.configure")
