#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDUtilsTable.py 474 2008-07-30 15:51:54Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                         import EDObject
from EDImport                         import EDString


class EDUtilsTable (EDObject):
    """
    This class allows to handle an XSDataTable objects (composed with lists that contain items)
    """
    
    def getTableFromTables( _xsTables, _oedTableName ):
        """
        """
        xsMatchTable = None
        xsTables = _xsTables.getTable()
        for xsTable in xsTables:
            oedStringTableName = EDString( xsTable.getName() )
            if ( oedStringTableName.equals( _oedTableName ) ):
                xsMatchTable = xsTable
                
        return xsMatchTable
    getTableFromTables = staticmethod( getTableFromTables )
    
    
    def getListsFromTable( _xsTable, _oedStringListName ):
        """
        """
        xsMatchLists = []
        xsLists = _xsTable.getList()
        for xsList in xsLists:
            oedStringListName = EDString( xsList.getName() )
            if ( oedStringListName.equals( _oedStringListName ) ):
                xsMatchLists.append( xsList )
                
        return xsMatchLists
    getListsFromTable = staticmethod( getListsFromTable )
    
    
    def getItemFromList( _xsList, _oedStringItemName ):
        """
        """
        xsMatchItem = None
        xsItems = _xsList.getItem()
        for xsItem in xsItems:
            oedStringItemName = EDString( xsItem.getName() )
            if ( oedStringItemName.equals( _oedStringItemName ) ):
                xsMatchItem = xsItem
                
        return xsMatchItem
    getItemFromList = staticmethod( getItemFromList ) 
        
    
   