#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDTestCasePlugin.py 476 2008-07-30 16:12:58Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                         import EDVerbose
from EDImport                         import EDString
from EDImport                         import EDDiskExplorer
from EDImportTest                     import EDUtilsPath
from EDImportTest                     import EDTestCase



class EDTestCasePlugin( EDTestCase ):
    """
    """
    
    def __init__( self, _oedStringPluginName, _oedStrPluginDir = None, _oedStringTestName = None ):
        """
        """
        EDTestCase.__init__( self, _oedStringTestName )
        
        self.m_oedStringPluginName = _oedStringPluginName
                        
        self.m_oedStrPluginHome = EDUtilsPath.getPluginsHome()
        if ( _oedStrPluginDir != None):
            self.m_oedStrPluginHome = EDDiskExplorer.mergePath( self.m_oedStrPluginHome, _oedStrPluginDir )
        
        self.m_oedStrTestsDataDir = None
        self.m_oedStrPluginTestsDataHome = None
                        
            
    def getPluginName( self ):
        """
        """
        return self.m_oedStringPluginName
    
    
    def getPluginHome( self ):
        """
        """
        return self.m_oedStrPluginHome
    
    
    def setPluginTestsDataDir( self, _oedStrPluginDataDir ):
        """
        """
        self.m_oedStrPluginTestsDataDir = _oedStrPluginDataDir
        
        
    def getPluginTestsDataHome( self ):
        """
        """
        return self.m_oedStrPluginTestsDataHome
        
        
    def setPluginTestsDataHome( self, _oedStrPluginTestsDataHome ):
        """
        """
        self.m_oedStrPluginTestsDataHome = _oedStrPluginTestsDataHome
        
        
           
                
