#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDUtilsTest.py 476 2008-07-30 16:12:58Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                         import EDObject
from EDImport                         import EDString
from EDImport                         import EDVerbose
from EDImportTest                     import EDUtilsPath


class EDUtilsTest (EDObject):
    """
    """
    def readAndParseFile( _oedStringFileName ):
        """
        """
        oedString = None
        try:
            oedString = EDUtilsTest.readFile ( _oedStringFileName )
        except:
            raise        
        
        if( oedString.contains( "${EDNA_TESTS_DATA_HOME}" ) ):
            oedString = EDString( oedString ).replace( "${EDNA_TESTS_DATA_HOME}" , EDUtilsPath.getTestsDataHome() )

        return oedString
    readAndParseFile = staticmethod( readAndParseFile )
    
    
    def readFile( _oedStringFileName ):
        """
        """
        oedString = None
        try:
            oedString = EDString( open( _oedStringFileName, "r" ).read() )
        except:
            EDVerbose.error( "*** EDUtilsTest.readFile: Problem when reading " + _oedStringFileName )
            raise        
        return oedString
    readFile = staticmethod( readFile )
    
    
    def writeFile( _oedStringFileName, _oedStringContent ):
        """
        """
        try:
            open( _oedStringFileName, "w" ).write( _oedStringContent )
        except:
            EDVerbose.error( "*** EDUtilsTest.writeFile: Problem when writing " + _oedStringFileName )
            raise        
    writeFile = staticmethod( writeFile )    
        
    
   