#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuitePluginExecute.py 476 2008-07-30 16:12:58Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                                             import EDCompiler
from EDImportTest                                         import EDTestSuite
from EDTestCasePluginExecuteMOSFLMv01Indexing             import EDTestCasePluginExecuteMOSFLMv01Indexing
from EDTestCasePluginExecuteMOSFLMv01IndexingWithForcedSymmetry import EDTestCasePluginExecuteMOSFLMv01IndexingWithForcedSymmetry
from EDTestCasePluginExecuteMOSFLMv01GeneratePrediction  import EDTestCasePluginExecuteMOSFLMv01GeneratePrediction
from EDTestCasePluginExecuteMOSFLMv01Integration          import EDTestCasePluginExecuteMOSFLMv01Integration
from EDTestCasePluginExecuteRaddosev01                    import EDTestCasePluginExecuteRaddosev01
from EDTestCasePluginExecuteBestv01                       import EDTestCasePluginExecuteBestv01
from EDTestCasePluginExecuteStrategyv01                   import EDTestCasePluginExecuteStrategyv01
from EDTestCasePluginExecuteControlIndexingv01            import EDTestCasePluginExecuteControlIndexingv01
from EDTestCasePluginExecuteControlIndexingv01withForcedSymmetry import EDTestCasePluginExecuteControlIndexingv01withForcedSymmetry
from EDTestCasePluginExecuteControlIntegrationv01         import EDTestCasePluginExecuteControlIntegrationv01
from EDTestCasePluginExecuteControlCharacterisationv01    import EDTestCasePluginExecuteControlCharacterisationv01
from EDTestCasePluginExecuteControlCharacterisationv01withForcedSpaceGroup import EDTestCasePluginExecuteControlCharacterisationv01withForcedSpaceGroup
from EDTestCasePluginExecuteControlGeneratePredictionv01 import EDTestCasePluginExecuteControlGeneratePredictionv01
from EDTestCasePluginExecuteReadImageHeaderv01            import EDTestCasePluginExecuteReadImageHeaderv01
from EDTestCasePluginExecuteStrategyv01WithoutChemComposition import EDTestCasePluginExecuteStrategyv01WithoutChemComposition

class EDTestSuitePluginExecute( EDTestSuite ):
        

    def process( self ):
        """
        """
        self.addTestMethod( EDTestCasePluginExecuteMOSFLMv01Indexing().execute )
        self.addTestMethod( EDTestCasePluginExecuteMOSFLMv01IndexingWithForcedSymmetry().execute )
        self.addTestMethod( EDTestCasePluginExecuteMOSFLMv01Integration().execute )
        self.addTestMethod( EDTestCasePluginExecuteMOSFLMv01GeneratePrediction().execute )
        self.addTestMethod( EDTestCasePluginExecuteRaddosev01().execute )
        self.addTestMethod( EDTestCasePluginExecuteBestv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteStrategyv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteStrategyv01WithoutChemComposition().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlIndexingv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlIndexingv01withForcedSymmetry().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlIntegrationv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlCharacterisationv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlCharacterisationv01withForcedSpaceGroup().execute )
        self.addTestMethod( EDTestCasePluginExecuteControlGeneratePredictionv01().execute )
        self.addTestMethod( EDTestCasePluginExecuteReadImageHeaderv01().execute )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestSuitePluginExecute = EDTestSuitePluginExecute( "EDTestSuitePluginExecute" )
    edTestSuitePluginExecute.execute()

##############################################################################