#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuitePluginUnit.py 476 2008-07-30 16:12:58Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                                      import EDCompiler
from EDImportTest                                  import EDTestSuite
from EDTestCasePluginUnitMessagePerClass           import EDTestCasePluginUnitMessagePerClass
from EDTestCasePluginUnitMessagePerMethod          import EDTestCasePluginUnitMessagePerMethod
from EDTestCasePluginUnitMOSFLMv01                 import EDTestCasePluginUnitMOSFLMv01
from EDTestCasePluginUnitMOSFLMv01Indexing         import EDTestCasePluginUnitMOSFLMv01Indexing
from EDTestCasePluginUnitMOSFLMv01Integration      import EDTestCasePluginUnitMOSFLMv01Integration
from EDTestCasePluginUnitMOSFLMv01GeneratePrediction import EDTestCasePluginUnitMOSFLMv01GeneratePrediction
from EDTestCasePluginUnitImg2XDSv01                import EDTestCasePluginUnitImg2XDSv01
from EDTestCasePluginUnitXDSIndexingv01            import EDTestCasePluginUnitXDSIndexingv01
from EDTestCasePluginUnitXDSIntegrationv01         import EDTestCasePluginUnitXDSIntegrationv01
from EDTestCasePluginUnitRaddosev01                import EDTestCasePluginUnitRaddosev01
from EDTestCasePluginUnitBestv01                   import EDTestCasePluginUnitBestv01
from EDTestCasePluginUnitStrategyv01               import EDTestCasePluginUnitStrategyv01
from EDTestCasePluginUnitControlIndexingv01        import EDTestCasePluginUnitControlIndexingv01
from EDTestCasePluginUnitControlIntegrationv01     import EDTestCasePluginUnitControlIntegrationv01
from EDTestCasePluginUnitControlCharacterisationv01 import EDTestCasePluginUnitControlCharacterisationv01
from EDTestCasePluginUnitReadImageHeaderv01        import EDTestCasePluginUnitReadImageHeaderv01

class EDTestSuitePluginUnit( EDTestSuite ):
        

    def process( self ):
        """
        """
        self.addTestMethod( EDTestCasePluginUnitMessagePerClass().execute )
        self.addTestMethod( EDTestCasePluginUnitMessagePerMethod().execute )
        self.addTestMethod( EDTestCasePluginUnitMOSFLMv01().execute )
        self.addTestMethod( EDTestCasePluginUnitMOSFLMv01Indexing().execute )
        self.addTestMethod( EDTestCasePluginUnitMOSFLMv01Integration().execute )
        self.addTestMethod( EDTestCasePluginUnitMOSFLMv01GeneratePrediction().execute )
        #self.addTestMethod( EDTestCasePluginUnitImg2XDSv01().execute )
        #self.addTestMethod( EDTestCasePluginUnitXDSIndexingv01().execute )
        #self.addTestMethod( EDTestCasePluginUnitXDSIntegrationv01().execute )
        self.addTestMethod( EDTestCasePluginUnitRaddosev01().execute )
        self.addTestMethod( EDTestCasePluginUnitBestv01().execute )
        self.addTestMethod( EDTestCasePluginUnitStrategyv01().execute )
        self.addTestMethod( EDTestCasePluginUnitControlIndexingv01().execute )
        self.addTestMethod( EDTestCasePluginUnitControlIntegrationv01().execute )
        self.addTestMethod( EDTestCasePluginUnitControlCharacterisationv01().execute )
#        self.addTestMethod( EDTestCasePluginUnitReadImageHeaderv01().execute )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestSuitePluginUnit = EDTestSuitePluginUnit( "EDTestSuitePluginUnit" )
    edTestSuitePluginUnit.execute()

##############################################################################