#
#    Project: The EDNA Prototype
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuiteSrc.py 476 2008-07-30 16:12:58Z svensson $"
#
#    Copyright (C) 2008 European Synchrotron Radiation Facility
#                       Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImport                             import EDCompiler
from EDImportTest                         import EDTestSuite
from EDTestCaseEDConfiguration            import EDTestCaseEDConfiguration
from EDTestCaseEDPluginExecProcessScript  import EDTestCaseEDPluginExecProcessScript
from EDTestCaseEDUtilsImage               import EDTestCaseEDUtilsImage
from EDTestCaseEDUtilsTable               import EDTestCaseEDUtilsTable


class EDTestSuiteSrc( EDTestSuite ):


    def process( self ):
        self.addTestMethod( EDTestCaseEDConfiguration().execute )
        self.addTestMethod( EDTestCaseEDPluginExecProcessScript().execute )
        self.addTestMethod( EDTestCaseEDUtilsImage().execute )
        self.addTestMethod( EDTestCaseEDUtilsTable().execute )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    oedTestSuiteSrc = EDTestSuiteSrc( "EDTestSuiteSrc" )
    oedTestSuiteSrc.execute()

##############################################################################
