#!/bin/bash
# Usage: $0 xsDataBaseName xsDataSuffix dirXSD dirDataBinding
xsDataBaseName=$1
xsDataSuffix=$2
dirXSD=$3
dirDataBinding=$4
if [ -z "$xsDataBaseName" ]; then
  echo "ERROR! This script cannot be launched stand-alone!"
  exit 1
fi
echo "Generating data bindings for ${xsDataBaseName}:" 
pathGenerateDS=${EDNA_HOME}/prototype/utils/datamodel/EDGenerateDS.py
pathXSD=${dirXSD}/${xsDataBaseName}.${xsDataSuffix}
echo "XSD input file ${pathXSD}"
if [ -z ${pathXSD} ]; then
	echo "ERROR! XSD file ${pathXSD} does not exist!"
	exit 1
fi
pathPython=${dirDataBinding}/${xsDataBaseName}.py
echo "Python output file: ${pathPython}" 
/bin/rm -rf ${pathPython}
python ${pathGenerateDS} --use-old-getter-setter  -a "xs:" -o ${pathPython} ${pathXSD}
echo "Done generating ${pathPython}"
