#!/usr/bin/env python

#
# Generated Tue Jul 29 15:56:31 2008 by EDGenerateDS.py.
#

import sys
import getopt
import StringIO
from xml.dom import minidom
from xml.dom import Node

#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

def quote_xml(inStr):
    s1 = inStr
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('"', '&quot;')
    return s1

def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, name)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (self.name, self.value, self.name))
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s",\n' % \
                (self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class _MemberSpec(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type(self): return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container


#
# Data representation classes.
#

class XSData:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if XSData.subclass:
            return XSData.subclass(*args_, **kwargs_)
        else:
            return XSData(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='XSData'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSData'):
        pass
    def exportChildren(self, outfile, level, name_='XSData'):
        outfile.write(self.valueOf_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSData' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSData.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSData.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSData" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSData'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class XSData


class XSDataGoniostat(XSData):
    subclass = None
    def __init__(self, maxOscillationSpeed=None, minOscillationWidth=None, oscillationWidth=None, rotationAxis=None, rotationAxisEnd=None, rotationAxisStart=None):
        XSData.__init__(self)
        self.maxOscillationSpeed = maxOscillationSpeed
        self.minOscillationWidth = minOscillationWidth
        self.oscillationWidth = oscillationWidth
        self.rotationAxis = rotationAxis
        self.rotationAxisEnd = rotationAxisEnd
        self.rotationAxisStart = rotationAxisStart
    def factory(*args_, **kwargs_):
        if XSDataGoniostat.subclass:
            return XSDataGoniostat.subclass(*args_, **kwargs_)
        else:
            return XSDataGoniostat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMaxOscillationSpeed(self): return self.maxOscillationSpeed
    def setMaxOscillationSpeed(self, maxOscillationSpeed): self.maxOscillationSpeed = maxOscillationSpeed
    def getMinOscillationWidth(self): return self.minOscillationWidth
    def setMinOscillationWidth(self, minOscillationWidth): self.minOscillationWidth = minOscillationWidth
    def getOscillationWidth(self): return self.oscillationWidth
    def setOscillationWidth(self, oscillationWidth): self.oscillationWidth = oscillationWidth
    def getRotationAxis(self): return self.rotationAxis
    def setRotationAxis(self, rotationAxis): self.rotationAxis = rotationAxis
    def getRotationAxisEnd(self): return self.rotationAxisEnd
    def setRotationAxisEnd(self, rotationAxisEnd): self.rotationAxisEnd = rotationAxisEnd
    def getRotationAxisStart(self): return self.rotationAxisStart
    def setRotationAxisStart(self, rotationAxisStart): self.rotationAxisStart = rotationAxisStart
    def export(self, outfile, level, name_='XSDataGoniostat'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataGoniostat'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataGoniostat')
    def exportChildren(self, outfile, level, name_='XSDataGoniostat'):
        if self.maxOscillationSpeed:
            self.maxOscillationSpeed.export(outfile, level, name_='maxOscillationSpeed')
        if self.minOscillationWidth:
            self.minOscillationWidth.export(outfile, level, name_='minOscillationWidth')
        if self.oscillationWidth:
            self.oscillationWidth.export(outfile, level, name_='oscillationWidth')
        if self.rotationAxis:
            self.rotationAxis.export(outfile, level, name_='rotationAxis')
        if self.rotationAxisEnd:
            self.rotationAxisEnd.export(outfile, level, name_='rotationAxisEnd')
        if self.rotationAxisStart:
            self.rotationAxisStart.export(outfile, level, name_='rotationAxisStart')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataGoniostat' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataGoniostat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataGoniostat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataGoniostat" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataGoniostat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.maxOscillationSpeed:
            showIndent(outfile, level)
            outfile.write('maxOscillationSpeed=XSDataAngularSpeed(\n')
            self.maxOscillationSpeed.exportLiteral(outfile, level, name_='maxOscillationSpeed')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.minOscillationWidth:
            showIndent(outfile, level)
            outfile.write('minOscillationWidth=XSDataAngle(\n')
            self.minOscillationWidth.exportLiteral(outfile, level, name_='minOscillationWidth')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.oscillationWidth:
            showIndent(outfile, level)
            outfile.write('oscillationWidth=XSDataAngle(\n')
            self.oscillationWidth.exportLiteral(outfile, level, name_='oscillationWidth')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxis:
            showIndent(outfile, level)
            outfile.write('rotationAxis=XSDataString(\n')
            self.rotationAxis.exportLiteral(outfile, level, name_='rotationAxis')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxisEnd:
            showIndent(outfile, level)
            outfile.write('rotationAxisEnd=XSDataAngle(\n')
            self.rotationAxisEnd.exportLiteral(outfile, level, name_='rotationAxisEnd')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxisStart:
            showIndent(outfile, level)
            outfile.write('rotationAxisStart=XSDataAngle(\n')
            self.rotationAxisStart.exportLiteral(outfile, level, name_='rotationAxisStart')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maxOscillationSpeed':
            obj_ = XSDataAngularSpeed.factory()
            obj_.build(child_)
            self.setMaxOscillationSpeed(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'minOscillationWidth':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setMinOscillationWidth(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'oscillationWidth':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setOscillationWidth(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxis':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setRotationAxis(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxisEnd':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setRotationAxisEnd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxisStart':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setRotationAxisStart(obj_)
# end class XSDataGoniostat


class XSDataChain(XSData):
    subclass = None
    def __init__(self, heavyAtoms=None, numberOfCopies=None, numberOfMonomers=None, typexx=None):
        XSData.__init__(self)
        self.heavyAtoms = heavyAtoms
        self.numberOfCopies = numberOfCopies
        self.numberOfMonomers = numberOfMonomers
        self.typexx = typexx
    def factory(*args_, **kwargs_):
        if XSDataChain.subclass:
            return XSDataChain.subclass(*args_, **kwargs_)
        else:
            return XSDataChain(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHeavyAtoms(self): return self.heavyAtoms
    def setHeavyAtoms(self, heavyAtoms): self.heavyAtoms = heavyAtoms
    def getNumberOfCopies(self): return self.numberOfCopies
    def setNumberOfCopies(self, numberOfCopies): self.numberOfCopies = numberOfCopies
    def getNumberOfMonomers(self): return self.numberOfMonomers
    def setNumberOfMonomers(self, numberOfMonomers): self.numberOfMonomers = numberOfMonomers
    def getType(self): return self.typexx
    def setType(self, typexx): self.typexx = typexx
    def export(self, outfile, level, name_='XSDataChain'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataChain'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataChain')
    def exportChildren(self, outfile, level, name_='XSDataChain'):
        if self.heavyAtoms:
            self.heavyAtoms.export(outfile, level, name_='heavyAtoms')
        if self.numberOfCopies:
            self.numberOfCopies.export(outfile, level, name_='numberOfCopies')
        if self.numberOfMonomers:
            self.numberOfMonomers.export(outfile, level, name_='numberOfMonomers')
        if self.typexx:
            self.typexx.export(outfile, level, name_='type')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataChain' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataChain.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataChain.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataChain" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataChain'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.heavyAtoms:
            showIndent(outfile, level)
            outfile.write('heavyAtoms=XSDataAtomicComposition(\n')
            self.heavyAtoms.exportLiteral(outfile, level, name_='heavyAtoms')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfCopies:
            showIndent(outfile, level)
            outfile.write('numberOfCopies=XSDataFloat(\n')
            self.numberOfCopies.exportLiteral(outfile, level, name_='numberOfCopies')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfMonomers:
            showIndent(outfile, level)
            outfile.write('numberOfMonomers=XSDataFloat(\n')
            self.numberOfMonomers.exportLiteral(outfile, level, name_='numberOfMonomers')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.typexx:
            showIndent(outfile, level)
            outfile.write('typexx=XSDataString(\n')
            self.typexx.exportLiteral(outfile, level, name_='type')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'heavyAtoms':
            obj_ = XSDataAtomicComposition.factory()
            obj_.build(child_)
            self.setHeavyAtoms(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfCopies':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setNumberOfCopies(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfMonomers':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setNumberOfMonomers(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setType(obj_)
# end class XSDataChain


class XSDataCell(XSData):
    subclass = None
    def __init__(self, angle_alpha=None, angle_beta=None, angle_gamma=None, length_a=None, length_b=None, length_c=None):
        XSData.__init__(self)
        self.angle_alpha = angle_alpha
        self.angle_beta = angle_beta
        self.angle_gamma = angle_gamma
        self.length_a = length_a
        self.length_b = length_b
        self.length_c = length_c
    def factory(*args_, **kwargs_):
        if XSDataCell.subclass:
            return XSDataCell.subclass(*args_, **kwargs_)
        else:
            return XSDataCell(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAngle_alpha(self): return self.angle_alpha
    def setAngle_alpha(self, angle_alpha): self.angle_alpha = angle_alpha
    def getAngle_beta(self): return self.angle_beta
    def setAngle_beta(self, angle_beta): self.angle_beta = angle_beta
    def getAngle_gamma(self): return self.angle_gamma
    def setAngle_gamma(self, angle_gamma): self.angle_gamma = angle_gamma
    def getLength_a(self): return self.length_a
    def setLength_a(self, length_a): self.length_a = length_a
    def getLength_b(self): return self.length_b
    def setLength_b(self, length_b): self.length_b = length_b
    def getLength_c(self): return self.length_c
    def setLength_c(self, length_c): self.length_c = length_c
    def export(self, outfile, level, name_='XSDataCell'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataCell'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataCell')
    def exportChildren(self, outfile, level, name_='XSDataCell'):
        if self.angle_alpha:
            self.angle_alpha.export(outfile, level, name_='angle_alpha')
        if self.angle_beta:
            self.angle_beta.export(outfile, level, name_='angle_beta')
        if self.angle_gamma:
            self.angle_gamma.export(outfile, level, name_='angle_gamma')
        if self.length_a:
            self.length_a.export(outfile, level, name_='length_a')
        if self.length_b:
            self.length_b.export(outfile, level, name_='length_b')
        if self.length_c:
            self.length_c.export(outfile, level, name_='length_c')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataCell' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataCell.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataCell.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataCell" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataCell'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.angle_alpha:
            showIndent(outfile, level)
            outfile.write('angle_alpha=XSDataAngle(\n')
            self.angle_alpha.exportLiteral(outfile, level, name_='angle_alpha')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.angle_beta:
            showIndent(outfile, level)
            outfile.write('angle_beta=XSDataAngle(\n')
            self.angle_beta.exportLiteral(outfile, level, name_='angle_beta')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.angle_gamma:
            showIndent(outfile, level)
            outfile.write('angle_gamma=XSDataAngle(\n')
            self.angle_gamma.exportLiteral(outfile, level, name_='angle_gamma')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.length_a:
            showIndent(outfile, level)
            outfile.write('length_a=XSDataLength(\n')
            self.length_a.exportLiteral(outfile, level, name_='length_a')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.length_b:
            showIndent(outfile, level)
            outfile.write('length_b=XSDataLength(\n')
            self.length_b.exportLiteral(outfile, level, name_='length_b')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.length_c:
            showIndent(outfile, level)
            outfile.write('length_c=XSDataLength(\n')
            self.length_c.exportLiteral(outfile, level, name_='length_c')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'angle_alpha':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setAngle_alpha(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'angle_beta':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setAngle_beta(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'angle_gamma':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setAngle_gamma(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'length_a':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setLength_a(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'length_b':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setLength_b(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'length_c':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setLength_c(obj_)
# end class XSDataCell


class XSDataWavelength(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataWavelength.subclass:
            return XSDataWavelength.subclass(*args_, **kwargs_)
        else:
            return XSDataWavelength(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataWavelength'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataWavelength'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataWavelength')
    def exportChildren(self, outfile, level, name_='XSDataWavelength'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataWavelength' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataWavelength.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataWavelength.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataWavelength" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataWavelength'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataWavelength


class XSDataLigand(XSData):
    subclass = None
    def __init__(self, heavyAtoms=None, numberOfCopies=None, numberOfLightAtoms=None):
        XSData.__init__(self)
        self.heavyAtoms = heavyAtoms
        self.numberOfCopies = numberOfCopies
        self.numberOfLightAtoms = numberOfLightAtoms
    def factory(*args_, **kwargs_):
        if XSDataLigand.subclass:
            return XSDataLigand.subclass(*args_, **kwargs_)
        else:
            return XSDataLigand(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHeavyAtoms(self): return self.heavyAtoms
    def setHeavyAtoms(self, heavyAtoms): self.heavyAtoms = heavyAtoms
    def getNumberOfCopies(self): return self.numberOfCopies
    def setNumberOfCopies(self, numberOfCopies): self.numberOfCopies = numberOfCopies
    def getNumberOfLightAtoms(self): return self.numberOfLightAtoms
    def setNumberOfLightAtoms(self, numberOfLightAtoms): self.numberOfLightAtoms = numberOfLightAtoms
    def export(self, outfile, level, name_='XSDataLigand'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataLigand'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataLigand')
    def exportChildren(self, outfile, level, name_='XSDataLigand'):
        if self.heavyAtoms:
            self.heavyAtoms.export(outfile, level, name_='heavyAtoms')
        if self.numberOfCopies:
            self.numberOfCopies.export(outfile, level, name_='numberOfCopies')
        if self.numberOfLightAtoms:
            self.numberOfLightAtoms.export(outfile, level, name_='numberOfLightAtoms')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataLigand' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataLigand.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataLigand.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataLigand" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataLigand'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.heavyAtoms:
            showIndent(outfile, level)
            outfile.write('heavyAtoms=XSDataAtomicComposition(\n')
            self.heavyAtoms.exportLiteral(outfile, level, name_='heavyAtoms')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfCopies:
            showIndent(outfile, level)
            outfile.write('numberOfCopies=XSDataFloat(\n')
            self.numberOfCopies.exportLiteral(outfile, level, name_='numberOfCopies')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfLightAtoms:
            showIndent(outfile, level)
            outfile.write('numberOfLightAtoms=XSDataFloat(\n')
            self.numberOfLightAtoms.exportLiteral(outfile, level, name_='numberOfLightAtoms')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'heavyAtoms':
            obj_ = XSDataAtomicComposition.factory()
            obj_.build(child_)
            self.setHeavyAtoms(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfCopies':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setNumberOfCopies(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfLightAtoms':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setNumberOfLightAtoms(obj_)
# end class XSDataLigand


class XSDataSolvent(XSData):
    subclass = None
    def __init__(self, atoms=None):
        XSData.__init__(self)
        self.atoms = atoms
    def factory(*args_, **kwargs_):
        if XSDataSolvent.subclass:
            return XSDataSolvent.subclass(*args_, **kwargs_)
        else:
            return XSDataSolvent(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAtoms(self): return self.atoms
    def setAtoms(self, atoms): self.atoms = atoms
    def export(self, outfile, level, name_='XSDataSolvent'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSolvent'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSolvent')
    def exportChildren(self, outfile, level, name_='XSDataSolvent'):
        if self.atoms:
            self.atoms.export(outfile, level, name_='atoms')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSolvent' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSolvent.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSolvent.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSolvent" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSolvent'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.atoms:
            showIndent(outfile, level)
            outfile.write('atoms=XSDataAtomicComposition(\n')
            self.atoms.exportLiteral(outfile, level, name_='atoms')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'atoms':
            obj_ = XSDataAtomicComposition.factory()
            obj_.build(child_)
            self.setAtoms(obj_)
# end class XSDataSolvent


class XSDataMatrix(XSData):
    subclass = None
    def __init__(self, m11=0.0, m12=0.0, m13=0.0, m21=0.0, m22=0.0, m23=0.0, m31=0.0, m32=0.0, m33=0.0):
        XSData.__init__(self)
        self.m11 = m11
        self.m12 = m12
        self.m13 = m13
        self.m21 = m21
        self.m22 = m22
        self.m23 = m23
        self.m31 = m31
        self.m32 = m32
        self.m33 = m33
    def factory(*args_, **kwargs_):
        if XSDataMatrix.subclass:
            return XSDataMatrix.subclass(*args_, **kwargs_)
        else:
            return XSDataMatrix(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getM11(self): return self.m11
    def setM11(self, m11): self.m11 = m11
    def getM12(self): return self.m12
    def setM12(self, m12): self.m12 = m12
    def getM13(self): return self.m13
    def setM13(self, m13): self.m13 = m13
    def getM21(self): return self.m21
    def setM21(self, m21): self.m21 = m21
    def getM22(self): return self.m22
    def setM22(self, m22): self.m22 = m22
    def getM23(self): return self.m23
    def setM23(self, m23): self.m23 = m23
    def getM31(self): return self.m31
    def setM31(self, m31): self.m31 = m31
    def getM32(self): return self.m32
    def setM32(self, m32): self.m32 = m32
    def getM33(self): return self.m33
    def setM33(self, m33): self.m33 = m33
    def export(self, outfile, level, name_='XSDataMatrix'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMatrix'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMatrix')
    def exportChildren(self, outfile, level, name_='XSDataMatrix'):
        showIndent(outfile, level)
        outfile.write('<m11>%e</m11>\n' % self.getM11())
        showIndent(outfile, level)
        outfile.write('<m12>%e</m12>\n' % self.getM12())
        showIndent(outfile, level)
        outfile.write('<m13>%e</m13>\n' % self.getM13())
        showIndent(outfile, level)
        outfile.write('<m21>%e</m21>\n' % self.getM21())
        showIndent(outfile, level)
        outfile.write('<m22>%e</m22>\n' % self.getM22())
        showIndent(outfile, level)
        outfile.write('<m23>%e</m23>\n' % self.getM23())
        showIndent(outfile, level)
        outfile.write('<m31>%e</m31>\n' % self.getM31())
        showIndent(outfile, level)
        outfile.write('<m32>%e</m32>\n' % self.getM32())
        showIndent(outfile, level)
        outfile.write('<m33>%e</m33>\n' % self.getM33())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMatrix' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMatrix.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMatrix.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMatrix" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMatrix'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('m11=%e,\n' % self.getM11())
        showIndent(outfile, level)
        outfile.write('m12=%e,\n' % self.getM12())
        showIndent(outfile, level)
        outfile.write('m13=%e,\n' % self.getM13())
        showIndent(outfile, level)
        outfile.write('m21=%e,\n' % self.getM21())
        showIndent(outfile, level)
        outfile.write('m22=%e,\n' % self.getM22())
        showIndent(outfile, level)
        outfile.write('m23=%e,\n' % self.getM23())
        showIndent(outfile, level)
        outfile.write('m31=%e,\n' % self.getM31())
        showIndent(outfile, level)
        outfile.write('m32=%e,\n' % self.getM32())
        showIndent(outfile, level)
        outfile.write('m33=%e,\n' % self.getM33())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm11':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m11 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm12':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m12 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm13':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m13 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm21':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m21 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm22':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m22 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm23':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m23 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm31':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m31 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm32':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m32 = fval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'm33':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.m33 = fval_
# end class XSDataMatrix


class XSDataAtomicComposition(XSData):
    subclass = None
    def __init__(self, atom=None):
        XSData.__init__(self)
        if atom is None:
            self.atom = []
        else:
            self.atom = atom
    def factory(*args_, **kwargs_):
        if XSDataAtomicComposition.subclass:
            return XSDataAtomicComposition.subclass(*args_, **kwargs_)
        else:
            return XSDataAtomicComposition(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAtom(self): return self.atom
    def setAtom(self, atom): self.atom = atom
    def addAtom(self, value): self.atom.append(value)
    def insertAtom(self, index, value): self.atom[index] = value
    def export(self, outfile, level, name_='XSDataAtomicComposition'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataAtomicComposition'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataAtomicComposition')
    def exportChildren(self, outfile, level, name_='XSDataAtomicComposition'):
        for atom_ in self.getAtom():
            atom_.export(outfile, level, name_='atom')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataAtomicComposition' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataAtomicComposition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataAtomicComposition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataAtomicComposition" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataAtomicComposition'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('atom=[\n')
        level += 1
        for atom in self.atom:
            showIndent(outfile, level)
            outfile.write('XSDataAtom(\n')
            atom.exportLiteral(outfile, level, name_='atom')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'atom':
            obj_ = XSDataAtom.factory()
            obj_.build(child_)
            self.atom.append(obj_)
# end class XSDataAtomicComposition


class XSDataChemicalCompositionMM(XSData):
    subclass = None
    def __init__(self, solvent=None, structure=None):
        XSData.__init__(self)
        self.solvent = solvent
        self.structure = structure
    def factory(*args_, **kwargs_):
        if XSDataChemicalCompositionMM.subclass:
            return XSDataChemicalCompositionMM.subclass(*args_, **kwargs_)
        else:
            return XSDataChemicalCompositionMM(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSolvent(self): return self.solvent
    def setSolvent(self, solvent): self.solvent = solvent
    def getStructure(self): return self.structure
    def setStructure(self, structure): self.structure = structure
    def export(self, outfile, level, name_='XSDataChemicalCompositionMM'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataChemicalCompositionMM'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataChemicalCompositionMM')
    def exportChildren(self, outfile, level, name_='XSDataChemicalCompositionMM'):
        if self.solvent:
            self.solvent.export(outfile, level, name_='solvent')
        if self.structure:
            self.structure.export(outfile, level, name_='structure')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataChemicalCompositionMM' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataChemicalCompositionMM.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataChemicalCompositionMM.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataChemicalCompositionMM" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataChemicalCompositionMM'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.solvent:
            showIndent(outfile, level)
            outfile.write('solvent=XSDataSolvent(\n')
            self.solvent.exportLiteral(outfile, level, name_='solvent')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.structure:
            showIndent(outfile, level)
            outfile.write('structure=XSDataStructure(\n')
            self.structure.exportLiteral(outfile, level, name_='structure')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'solvent':
            obj_ = XSDataSolvent.factory()
            obj_.build(child_)
            self.setSolvent(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'structure':
            obj_ = XSDataStructure.factory()
            obj_.build(child_)
            self.setStructure(obj_)
# end class XSDataChemicalCompositionMM


class XSDataMOSFLMBeamPosition(XSData):
    subclass = None
    def __init__(self, x=None, y=None):
        XSData.__init__(self)
        self.x = x
        self.y = y
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMBeamPosition.subclass:
            return XSDataMOSFLMBeamPosition.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMBeamPosition(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getX(self): return self.x
    def setX(self, x): self.x = x
    def getY(self): return self.y
    def setY(self, y): self.y = y
    def export(self, outfile, level, name_='XSDataMOSFLMBeamPosition'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMBeamPosition'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMBeamPosition')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMBeamPosition'):
        if self.x:
            self.x.export(outfile, level, name_='x')
        if self.y:
            self.y.export(outfile, level, name_='y')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMBeamPosition' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMBeamPosition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMBeamPosition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMBeamPosition" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMBeamPosition'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.x:
            showIndent(outfile, level)
            outfile.write('x=XSDataLength(\n')
            self.x.exportLiteral(outfile, level, name_='x')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.y:
            showIndent(outfile, level)
            outfile.write('y=XSDataLength(\n')
            self.y.exportLiteral(outfile, level, name_='y')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'x':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'y':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setY(obj_)
# end class XSDataMOSFLMBeamPosition


class XSDataMOSFLMOutputGeneratePrediction(XSData):
    subclass = None
    def __init__(self, predictionImage=None):
        XSData.__init__(self)
        self.predictionImage = predictionImage
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMOutputGeneratePrediction.subclass:
            return XSDataMOSFLMOutputGeneratePrediction.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMOutputGeneratePrediction(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPredictionImage(self): return self.predictionImage
    def setPredictionImage(self, predictionImage): self.predictionImage = predictionImage
    def export(self, outfile, level, name_='XSDataMOSFLMOutputGeneratePrediction'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputGeneratePrediction'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputGeneratePrediction')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMOutputGeneratePrediction'):
        if self.predictionImage:
            self.predictionImage.export(outfile, level, name_='predictionImage')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMOutputGeneratePrediction' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputGeneratePrediction.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputGeneratePrediction.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMOutputGeneratePrediction" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMOutputGeneratePrediction'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.predictionImage:
            showIndent(outfile, level)
            outfile.write('predictionImage=XSDataImage(\n')
            self.predictionImage.exportLiteral(outfile, level, name_='predictionImage')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'predictionImage':
            obj_ = XSDataImage.factory()
            obj_.build(child_)
            self.setPredictionImage(obj_)
# end class XSDataMOSFLMOutputGeneratePrediction


class XSDataMOSFLMIntegrationStatistics(XSData):
    subclass = None
    def __init__(self, averageIntensity=None, averageIOverSigma=None, averageSigma=None, numberOfReflections=None):
        XSData.__init__(self)
        self.averageIntensity = averageIntensity
        self.averageIOverSigma = averageIOverSigma
        self.averageSigma = averageSigma
        self.numberOfReflections = numberOfReflections
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMIntegrationStatistics.subclass:
            return XSDataMOSFLMIntegrationStatistics.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMIntegrationStatistics(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAverageIntensity(self): return self.averageIntensity
    def setAverageIntensity(self, averageIntensity): self.averageIntensity = averageIntensity
    def getAverageIOverSigma(self): return self.averageIOverSigma
    def setAverageIOverSigma(self, averageIOverSigma): self.averageIOverSigma = averageIOverSigma
    def getAverageSigma(self): return self.averageSigma
    def setAverageSigma(self, averageSigma): self.averageSigma = averageSigma
    def getNumberOfReflections(self): return self.numberOfReflections
    def setNumberOfReflections(self, numberOfReflections): self.numberOfReflections = numberOfReflections
    def export(self, outfile, level, name_='XSDataMOSFLMIntegrationStatistics'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatistics'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatistics')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMIntegrationStatistics'):
        if self.averageIntensity:
            self.averageIntensity.export(outfile, level, name_='averageIntensity')
        if self.averageIOverSigma:
            self.averageIOverSigma.export(outfile, level, name_='averageIOverSigma')
        if self.averageSigma:
            self.averageSigma.export(outfile, level, name_='averageSigma')
        if self.numberOfReflections:
            self.numberOfReflections.export(outfile, level, name_='numberOfReflections')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMIntegrationStatistics' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatistics.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatistics.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMIntegrationStatistics" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMIntegrationStatistics'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.averageIntensity:
            showIndent(outfile, level)
            outfile.write('averageIntensity=XSDataFloat(\n')
            self.averageIntensity.exportLiteral(outfile, level, name_='averageIntensity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.averageIOverSigma:
            showIndent(outfile, level)
            outfile.write('averageIOverSigma=XSDataFloat(\n')
            self.averageIOverSigma.exportLiteral(outfile, level, name_='averageIOverSigma')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.averageSigma:
            showIndent(outfile, level)
            outfile.write('averageSigma=XSDataFloat(\n')
            self.averageSigma.exportLiteral(outfile, level, name_='averageSigma')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfReflections:
            showIndent(outfile, level)
            outfile.write('numberOfReflections=XSDataInteger(\n')
            self.numberOfReflections.exportLiteral(outfile, level, name_='numberOfReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'averageIntensity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAverageIntensity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'averageIOverSigma':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAverageIOverSigma(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'averageSigma':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAverageSigma(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfReflections(obj_)
# end class XSDataMOSFLMIntegrationStatistics


class XSDataMOSFLMDetector:
    subclass = None
    def __init__(self, numberPixelX=None, numberPixelY=None, pixelSizeX=None, pixelSizeY=None, typexx=None):
        self.numberPixelX = numberPixelX
        self.numberPixelY = numberPixelY
        self.pixelSizeX = pixelSizeX
        self.pixelSizeY = pixelSizeY
        self.typexx = typexx
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMDetector.subclass:
            return XSDataMOSFLMDetector.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMDetector(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getNumberPixelX(self): return self.numberPixelX
    def setNumberPixelX(self, numberPixelX): self.numberPixelX = numberPixelX
    def getNumberPixelY(self): return self.numberPixelY
    def setNumberPixelY(self, numberPixelY): self.numberPixelY = numberPixelY
    def getPixelSizeX(self): return self.pixelSizeX
    def setPixelSizeX(self, pixelSizeX): self.pixelSizeX = pixelSizeX
    def getPixelSizeY(self): return self.pixelSizeY
    def setPixelSizeY(self, pixelSizeY): self.pixelSizeY = pixelSizeY
    def getType(self): return self.typexx
    def setType(self, typexx): self.typexx = typexx
    def export(self, outfile, level, name_='XSDataMOSFLMDetector'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMDetector'):
        pass
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMDetector'):
        if self.numberPixelX:
            self.numberPixelX.export(outfile, level, name_='numberPixelX')
        if self.numberPixelY:
            self.numberPixelY.export(outfile, level, name_='numberPixelY')
        if self.pixelSizeX:
            self.pixelSizeX.export(outfile, level, name_='pixelSizeX')
        if self.pixelSizeY:
            self.pixelSizeY.export(outfile, level, name_='pixelSizeY')
        if self.typexx:
            self.typexx.export(outfile, level, name_='type')

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMDetector' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMDetector.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMDetector.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMDetector" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMDetector'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.numberPixelX:
            showIndent(outfile, level)
            outfile.write('numberPixelX=XSDataInteger(\n')
            self.numberPixelX.exportLiteral(outfile, level, name_='numberPixelX')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberPixelY:
            showIndent(outfile, level)
            outfile.write('numberPixelY=XSDataInteger(\n')
            self.numberPixelY.exportLiteral(outfile, level, name_='numberPixelY')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.pixelSizeX:
            showIndent(outfile, level)
            outfile.write('pixelSizeX=XSDataLength(\n')
            self.pixelSizeX.exportLiteral(outfile, level, name_='pixelSizeX')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.pixelSizeY:
            showIndent(outfile, level)
            outfile.write('pixelSizeY=XSDataLength(\n')
            self.pixelSizeY.exportLiteral(outfile, level, name_='pixelSizeY')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.typexx:
            showIndent(outfile, level)
            outfile.write('typexx=XSDataString(\n')
            self.typexx.exportLiteral(outfile, level, name_='type')
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberPixelX':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberPixelX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberPixelY':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberPixelY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pixelSizeX':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setPixelSizeX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pixelSizeY':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setPixelSizeY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setType(obj_)
# end class XSDataMOSFLMDetector


class XSDataMOSFLMMissettingsAngles(XSData):
    subclass = None
    def __init__(self, phix=None, phiy=None, phiz=None):
        XSData.__init__(self)
        self.phix = phix
        self.phiy = phiy
        self.phiz = phiz
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMMissettingsAngles.subclass:
            return XSDataMOSFLMMissettingsAngles.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMMissettingsAngles(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPhix(self): return self.phix
    def setPhix(self, phix): self.phix = phix
    def getPhiy(self): return self.phiy
    def setPhiy(self, phiy): self.phiy = phiy
    def getPhiz(self): return self.phiz
    def setPhiz(self, phiz): self.phiz = phiz
    def export(self, outfile, level, name_='XSDataMOSFLMMissettingsAngles'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMMissettingsAngles'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMMissettingsAngles')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMMissettingsAngles'):
        if self.phix:
            self.phix.export(outfile, level, name_='phix')
        if self.phiy:
            self.phiy.export(outfile, level, name_='phiy')
        if self.phiz:
            self.phiz.export(outfile, level, name_='phiz')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMMissettingsAngles' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMMissettingsAngles.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMMissettingsAngles.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMMissettingsAngles" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMMissettingsAngles'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.phix:
            showIndent(outfile, level)
            outfile.write('phix=XSDataAngle(\n')
            self.phix.exportLiteral(outfile, level, name_='phix')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.phiy:
            showIndent(outfile, level)
            outfile.write('phiy=XSDataAngle(\n')
            self.phiy.exportLiteral(outfile, level, name_='phiy')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.phiz:
            showIndent(outfile, level)
            outfile.write('phiz=XSDataAngle(\n')
            self.phiz.exportLiteral(outfile, level, name_='phiz')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phix':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setPhix(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phiy':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setPhiy(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phiz':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setPhiz(obj_)
# end class XSDataMOSFLMMissettingsAngles


class XSDataMOSFLMOutput(XSData):
    subclass = None
    def __init__(self, refinedBeam=None, refinedDistance=None, refinedNewmat=None):
        XSData.__init__(self)
        self.refinedBeam = refinedBeam
        self.refinedDistance = refinedDistance
        self.refinedNewmat = refinedNewmat
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMOutput.subclass:
            return XSDataMOSFLMOutput.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getRefinedBeam(self): return self.refinedBeam
    def setRefinedBeam(self, refinedBeam): self.refinedBeam = refinedBeam
    def getRefinedDistance(self): return self.refinedDistance
    def setRefinedDistance(self, refinedDistance): self.refinedDistance = refinedDistance
    def getRefinedNewmat(self): return self.refinedNewmat
    def setRefinedNewmat(self, refinedNewmat): self.refinedNewmat = refinedNewmat
    def export(self, outfile, level, name_='XSDataMOSFLMOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutput'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutput')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMOutput'):
        if self.refinedBeam:
            self.refinedBeam.export(outfile, level, name_='refinedBeam')
        if self.refinedDistance:
            self.refinedDistance.export(outfile, level, name_='refinedDistance')
        if self.refinedNewmat:
            self.refinedNewmat.export(outfile, level, name_='refinedNewmat')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMOutput' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutput.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutput.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMOutput" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMOutput'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.refinedBeam:
            showIndent(outfile, level)
            outfile.write('refinedBeam=XSDataMOSFLMBeamPosition(\n')
            self.refinedBeam.exportLiteral(outfile, level, name_='refinedBeam')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.refinedDistance:
            showIndent(outfile, level)
            outfile.write('refinedDistance=XSDataLength(\n')
            self.refinedDistance.exportLiteral(outfile, level, name_='refinedDistance')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.refinedNewmat:
            showIndent(outfile, level)
            outfile.write('refinedNewmat=XSDataMOSFLMNewmat(\n')
            self.refinedNewmat.exportLiteral(outfile, level, name_='refinedNewmat')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedBeam':
            obj_ = XSDataMOSFLMBeamPosition.factory()
            obj_.build(child_)
            self.setRefinedBeam(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedDistance':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setRefinedDistance(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedNewmat':
            obj_ = XSDataMOSFLMNewmat.factory()
            obj_.build(child_)
            self.setRefinedNewmat(obj_)
# end class XSDataMOSFLMOutput


class XSDataMOSFLMOutputPostRefinement(XSDataMOSFLMOutput):
    subclass = None
    def __init__(self, refinedBeam=None, refinedDistance=None, refinedNewmat=None, valueOf_=''):
        XSDataMOSFLMOutput.__init__(self, refinedBeam, refinedDistance, refinedNewmat)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMOutputPostRefinement.subclass:
            return XSDataMOSFLMOutputPostRefinement.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMOutputPostRefinement(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='XSDataMOSFLMOutputPostRefinement'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputPostRefinement'):
        XSDataMOSFLMOutput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputPostRefinement')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMOutputPostRefinement'):
        XSDataMOSFLMOutput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMOutputPostRefinement' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputPostRefinement.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputPostRefinement.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMOutputPostRefinement" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMOutputPostRefinement'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMOutput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
        XSDataMOSFLMOutput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMOutput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        XSDataMOSFLMOutput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMOutputPostRefinement


class XSDataMOSFLMNewmat(XSData):
    subclass = None
    def __init__(self, aMatrix=None, missettingAngles=None, refinedCell=None, uMatrix=None):
        XSData.__init__(self)
        self.aMatrix = aMatrix
        self.missettingAngles = missettingAngles
        self.refinedCell = refinedCell
        self.uMatrix = uMatrix
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMNewmat.subclass:
            return XSDataMOSFLMNewmat.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMNewmat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAMatrix(self): return self.aMatrix
    def setAMatrix(self, aMatrix): self.aMatrix = aMatrix
    def getMissettingAngles(self): return self.missettingAngles
    def setMissettingAngles(self, missettingAngles): self.missettingAngles = missettingAngles
    def getRefinedCell(self): return self.refinedCell
    def setRefinedCell(self, refinedCell): self.refinedCell = refinedCell
    def getUMatrix(self): return self.uMatrix
    def setUMatrix(self, uMatrix): self.uMatrix = uMatrix
    def export(self, outfile, level, name_='XSDataMOSFLMNewmat'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMNewmat'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMNewmat')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMNewmat'):
        if self.aMatrix:
            self.aMatrix.export(outfile, level, name_='aMatrix')
        if self.missettingAngles:
            self.missettingAngles.export(outfile, level, name_='missettingAngles')
        if self.refinedCell:
            self.refinedCell.export(outfile, level, name_='refinedCell')
        if self.uMatrix:
            self.uMatrix.export(outfile, level, name_='uMatrix')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMNewmat' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMNewmat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMNewmat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMNewmat" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMNewmat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.aMatrix:
            showIndent(outfile, level)
            outfile.write('aMatrix=XSDataMatrix(\n')
            self.aMatrix.exportLiteral(outfile, level, name_='aMatrix')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.missettingAngles:
            showIndent(outfile, level)
            outfile.write('missettingAngles=XSDataMOSFLMMissettingsAngles(\n')
            self.missettingAngles.exportLiteral(outfile, level, name_='missettingAngles')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.refinedCell:
            showIndent(outfile, level)
            outfile.write('refinedCell=XSDataCell(\n')
            self.refinedCell.exportLiteral(outfile, level, name_='refinedCell')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.uMatrix:
            showIndent(outfile, level)
            outfile.write('uMatrix=XSDataMatrix(\n')
            self.uMatrix.exportLiteral(outfile, level, name_='uMatrix')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aMatrix':
            obj_ = XSDataMatrix.factory()
            obj_.build(child_)
            self.setAMatrix(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'missettingAngles':
            obj_ = XSDataMOSFLMMissettingsAngles.factory()
            obj_.build(child_)
            self.setMissettingAngles(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedCell':
            obj_ = XSDataCell.factory()
            obj_.build(child_)
            self.setRefinedCell(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'uMatrix':
            obj_ = XSDataMatrix.factory()
            obj_.build(child_)
            self.setUMatrix(obj_)
# end class XSDataMOSFLMNewmat


class XSDataMOSFLMIntegrationStatisticsPerResolutionBin(XSData):
    subclass = None
    def __init__(self, maxResolution=None, minResolution=None, profileFitted=None, summation=None):
        XSData.__init__(self)
        self.maxResolution = maxResolution
        self.minResolution = minResolution
        self.profileFitted = profileFitted
        self.summation = summation
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMIntegrationStatisticsPerResolutionBin.subclass:
            return XSDataMOSFLMIntegrationStatisticsPerResolutionBin.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMIntegrationStatisticsPerResolutionBin(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMaxResolution(self): return self.maxResolution
    def setMaxResolution(self, maxResolution): self.maxResolution = maxResolution
    def getMinResolution(self): return self.minResolution
    def setMinResolution(self, minResolution): self.minResolution = minResolution
    def getProfileFitted(self): return self.profileFitted
    def setProfileFitted(self, profileFitted): self.profileFitted = profileFitted
    def getSummation(self): return self.summation
    def setSummation(self, summation): self.summation = summation
    def export(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin'):
        if self.maxResolution:
            self.maxResolution.export(outfile, level, name_='maxResolution')
        if self.minResolution:
            self.minResolution.export(outfile, level, name_='minResolution')
        if self.profileFitted:
            self.profileFitted.export(outfile, level, name_='profileFitted')
        if self.summation:
            self.summation.export(outfile, level, name_='summation')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMIntegrationStatisticsPerResolutionBin" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerResolutionBin'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.maxResolution:
            showIndent(outfile, level)
            outfile.write('maxResolution=XSDataFloat(\n')
            self.maxResolution.exportLiteral(outfile, level, name_='maxResolution')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.minResolution:
            showIndent(outfile, level)
            outfile.write('minResolution=XSDataFloat(\n')
            self.minResolution.exportLiteral(outfile, level, name_='minResolution')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.profileFitted:
            showIndent(outfile, level)
            outfile.write('profileFitted=XSDataMOSFLMIntegrationStatisticsPerReflectionType(\n')
            self.profileFitted.exportLiteral(outfile, level, name_='profileFitted')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.summation:
            showIndent(outfile, level)
            outfile.write('summation=XSDataMOSFLMIntegrationStatisticsPerReflectionType(\n')
            self.summation.exportLiteral(outfile, level, name_='summation')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maxResolution':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setMaxResolution(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'minResolution':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setMinResolution(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'profileFitted':
            obj_ = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
            obj_.build(child_)
            self.setProfileFitted(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'summation':
            obj_ = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
            obj_.build(child_)
            self.setSummation(obj_)
# end class XSDataMOSFLMIntegrationStatisticsPerResolutionBin


class XSDataMOSFLMInput(XSData):
    subclass = None
    def __init__(self, beam=None, detector=None, directory=None, distance=None, matrix=None, mosaicity=None, symmetry=None, template=None, wavelength=None):
        XSData.__init__(self)
        self.beam = beam
        self.detector = detector
        self.directory = directory
        self.distance = distance
        self.matrix = matrix
        self.mosaicity = mosaicity
        self.symmetry = symmetry
        self.template = template
        self.wavelength = wavelength
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMInput.subclass:
            return XSDataMOSFLMInput.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBeam(self): return self.beam
    def setBeam(self, beam): self.beam = beam
    def getDetector(self): return self.detector
    def setDetector(self, detector): self.detector = detector
    def getDirectory(self): return self.directory
    def setDirectory(self, directory): self.directory = directory
    def getDistance(self): return self.distance
    def setDistance(self, distance): self.distance = distance
    def getMatrix(self): return self.matrix
    def setMatrix(self, matrix): self.matrix = matrix
    def getMosaicity(self): return self.mosaicity
    def setMosaicity(self, mosaicity): self.mosaicity = mosaicity
    def getSymmetry(self): return self.symmetry
    def setSymmetry(self, symmetry): self.symmetry = symmetry
    def getTemplate(self): return self.template
    def setTemplate(self, template): self.template = template
    def getWavelength(self): return self.wavelength
    def setWavelength(self, wavelength): self.wavelength = wavelength
    def export(self, outfile, level, name_='XSDataMOSFLMInput'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMInput'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMInput')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMInput'):
        if self.beam:
            self.beam.export(outfile, level, name_='beam')
        if self.detector:
            self.detector.export(outfile, level, name_='detector')
        if self.directory:
            self.directory.export(outfile, level, name_='directory')
        if self.distance:
            self.distance.export(outfile, level, name_='distance')
        if self.matrix:
            self.matrix.export(outfile, level, name_='matrix')
        if self.mosaicity:
            self.mosaicity.export(outfile, level, name_='mosaicity')
        if self.symmetry:
            self.symmetry.export(outfile, level, name_='symmetry')
        if self.template:
            self.template.export(outfile, level, name_='template')
        if self.wavelength:
            self.wavelength.export(outfile, level, name_='wavelength')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMInput' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInput.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInput.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMInput" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMInput'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.beam:
            showIndent(outfile, level)
            outfile.write('beam=XSDataMOSFLMBeamPosition(\n')
            self.beam.exportLiteral(outfile, level, name_='beam')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.detector:
            showIndent(outfile, level)
            outfile.write('detector=XSDataMOSFLMDetector(\n')
            self.detector.exportLiteral(outfile, level, name_='detector')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.directory:
            showIndent(outfile, level)
            outfile.write('directory=XSDataString(\n')
            self.directory.exportLiteral(outfile, level, name_='directory')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.distance:
            showIndent(outfile, level)
            outfile.write('distance=XSDataLength(\n')
            self.distance.exportLiteral(outfile, level, name_='distance')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.matrix:
            showIndent(outfile, level)
            outfile.write('matrix=XSDataMOSFLMNewmat(\n')
            self.matrix.exportLiteral(outfile, level, name_='matrix')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.mosaicity:
            showIndent(outfile, level)
            outfile.write('mosaicity=XSDataFloat(\n')
            self.mosaicity.exportLiteral(outfile, level, name_='mosaicity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.symmetry:
            showIndent(outfile, level)
            outfile.write('symmetry=XSDataString(\n')
            self.symmetry.exportLiteral(outfile, level, name_='symmetry')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.template:
            showIndent(outfile, level)
            outfile.write('template=XSDataString(\n')
            self.template.exportLiteral(outfile, level, name_='template')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.wavelength:
            showIndent(outfile, level)
            outfile.write('wavelength=XSDataWavelength(\n')
            self.wavelength.exportLiteral(outfile, level, name_='wavelength')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'beam':
            obj_ = XSDataMOSFLMBeamPosition.factory()
            obj_.build(child_)
            self.setBeam(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'detector':
            obj_ = XSDataMOSFLMDetector.factory()
            obj_.build(child_)
            self.setDetector(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'directory':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setDirectory(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'distance':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setDistance(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'matrix':
            obj_ = XSDataMOSFLMNewmat.factory()
            obj_.build(child_)
            self.setMatrix(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mosaicity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setMosaicity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'symmetry':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setSymmetry(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'template':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setTemplate(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'wavelength':
            obj_ = XSDataWavelength.factory()
            obj_.build(child_)
            self.setWavelength(obj_)
# end class XSDataMOSFLMInput


class XSDataMOSFLMIndexingSolution(XSData):
    subclass = None
    def __init__(self, cell=None, index=None, lattice=None, penalty=None):
        XSData.__init__(self)
        self.cell = cell
        self.index = index
        self.lattice = lattice
        self.penalty = penalty
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMIndexingSolution.subclass:
            return XSDataMOSFLMIndexingSolution.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMIndexingSolution(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCell(self): return self.cell
    def setCell(self, cell): self.cell = cell
    def getIndex(self): return self.index
    def setIndex(self, index): self.index = index
    def getLattice(self): return self.lattice
    def setLattice(self, lattice): self.lattice = lattice
    def getPenalty(self): return self.penalty
    def setPenalty(self, penalty): self.penalty = penalty
    def export(self, outfile, level, name_='XSDataMOSFLMIndexingSolution'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMIndexingSolution'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMIndexingSolution')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMIndexingSolution'):
        if self.cell:
            self.cell.export(outfile, level, name_='cell')
        if self.index:
            self.index.export(outfile, level, name_='index')
        if self.lattice:
            self.lattice.export(outfile, level, name_='lattice')
        if self.penalty:
            self.penalty.export(outfile, level, name_='penalty')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMIndexingSolution' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIndexingSolution.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIndexingSolution.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMIndexingSolution" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMIndexingSolution'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.cell:
            showIndent(outfile, level)
            outfile.write('cell=XSDataCell(\n')
            self.cell.exportLiteral(outfile, level, name_='cell')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.index:
            showIndent(outfile, level)
            outfile.write('index=XSDataInteger(\n')
            self.index.exportLiteral(outfile, level, name_='index')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.lattice:
            showIndent(outfile, level)
            outfile.write('lattice=XSDataString(\n')
            self.lattice.exportLiteral(outfile, level, name_='lattice')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.penalty:
            showIndent(outfile, level)
            outfile.write('penalty=XSDataInteger(\n')
            self.penalty.exportLiteral(outfile, level, name_='penalty')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cell':
            obj_ = XSDataCell.factory()
            obj_.build(child_)
            self.setCell(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'index':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setIndex(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'lattice':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setLattice(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'penalty':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setPenalty(obj_)
# end class XSDataMOSFLMIndexingSolution


class XSDataMOSFLMImage(XSData):
    subclass = None
    def __init__(self, number=None, rotationAxisEnd=None, rotationAxisStart=None):
        XSData.__init__(self)
        self.number = number
        self.rotationAxisEnd = rotationAxisEnd
        self.rotationAxisStart = rotationAxisStart
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMImage.subclass:
            return XSDataMOSFLMImage.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMImage(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getNumber(self): return self.number
    def setNumber(self, number): self.number = number
    def getRotationAxisEnd(self): return self.rotationAxisEnd
    def setRotationAxisEnd(self, rotationAxisEnd): self.rotationAxisEnd = rotationAxisEnd
    def getRotationAxisStart(self): return self.rotationAxisStart
    def setRotationAxisStart(self, rotationAxisStart): self.rotationAxisStart = rotationAxisStart
    def export(self, outfile, level, name_='XSDataMOSFLMImage'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMImage'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMImage')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMImage'):
        if self.number:
            self.number.export(outfile, level, name_='number')
        if self.rotationAxisEnd:
            self.rotationAxisEnd.export(outfile, level, name_='rotationAxisEnd')
        if self.rotationAxisStart:
            self.rotationAxisStart.export(outfile, level, name_='rotationAxisStart')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMImage' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMImage.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMImage.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMImage" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMImage'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.number:
            showIndent(outfile, level)
            outfile.write('number=XSDataInteger(\n')
            self.number.exportLiteral(outfile, level, name_='number')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxisEnd:
            showIndent(outfile, level)
            outfile.write('rotationAxisEnd=XSDataAngle(\n')
            self.rotationAxisEnd.exportLiteral(outfile, level, name_='rotationAxisEnd')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxisStart:
            showIndent(outfile, level)
            outfile.write('rotationAxisStart=XSDataAngle(\n')
            self.rotationAxisStart.exportLiteral(outfile, level, name_='rotationAxisStart')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'number':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumber(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxisEnd':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setRotationAxisEnd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxisStart':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setRotationAxisStart(obj_)
# end class XSDataMOSFLMImage


class XSDataMOSFLMIntegrationStatisticsPerReflectionType(XSData):
    subclass = None
    def __init__(self, fullyRecorded=None, partials=None):
        XSData.__init__(self)
        self.fullyRecorded = fullyRecorded
        self.partials = partials
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMIntegrationStatisticsPerReflectionType.subclass:
            return XSDataMOSFLMIntegrationStatisticsPerReflectionType.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMIntegrationStatisticsPerReflectionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFullyRecorded(self): return self.fullyRecorded
    def setFullyRecorded(self, fullyRecorded): self.fullyRecorded = fullyRecorded
    def getPartials(self): return self.partials
    def setPartials(self, partials): self.partials = partials
    def export(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType'):
        if self.fullyRecorded:
            self.fullyRecorded.export(outfile, level, name_='fullyRecorded')
        if self.partials:
            self.partials.export(outfile, level, name_='partials')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMIntegrationStatisticsPerReflectionType" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMIntegrationStatisticsPerReflectionType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.fullyRecorded:
            showIndent(outfile, level)
            outfile.write('fullyRecorded=XSDataMOSFLMIntegrationStatistics(\n')
            self.fullyRecorded.exportLiteral(outfile, level, name_='fullyRecorded')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.partials:
            showIndent(outfile, level)
            outfile.write('partials=XSDataMOSFLMIntegrationStatistics(\n')
            self.partials.exportLiteral(outfile, level, name_='partials')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fullyRecorded':
            obj_ = XSDataMOSFLMIntegrationStatistics.factory()
            obj_.build(child_)
            self.setFullyRecorded(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'partials':
            obj_ = XSDataMOSFLMIntegrationStatistics.factory()
            obj_.build(child_)
            self.setPartials(obj_)
# end class XSDataMOSFLMIntegrationStatisticsPerReflectionType


class XSDataMOSFLMInputIndexing(XSDataMOSFLMInput):
    subclass = None
    def __init__(self, image=None, beam=None, detector=None, directory=None, distance=None, matrix=None, mosaicity=None, symmetry=None, template=None, wavelength=None):
        XSDataMOSFLMInput.__init__(self, beam, detector, directory, distance, matrix, mosaicity, symmetry, template, wavelength)
        if image is None:
            self.image = []
        else:
            self.image = image
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMInputIndexing.subclass:
            return XSDataMOSFLMInputIndexing.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMInputIndexing(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getImage(self): return self.image
    def setImage(self, image): self.image = image
    def addImage(self, value): self.image.append(value)
    def insertImage(self, index, value): self.image[index] = value
    def export(self, outfile, level, name_='XSDataMOSFLMInputIndexing'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputIndexing'):
        XSDataMOSFLMInput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputIndexing')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMInputIndexing'):
        for image_ in self.getImage():
            image_.export(outfile, level, name_='image')
        XSDataMOSFLMInput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMInputIndexing' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputIndexing.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputIndexing.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMInputIndexing" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMInputIndexing'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMInput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('image=[\n')
        level += 1
        for image in self.image:
            showIndent(outfile, level)
            outfile.write('XSDataMOSFLMImage(\n')
            image.exportLiteral(outfile, level, name_='image')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        XSDataMOSFLMInput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMInput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'image':
            obj_ = XSDataMOSFLMImage.factory()
            obj_.build(child_)
            self.image.append(obj_)
        XSDataMOSFLMInput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMInputIndexing


class XSDataMOSFLMInputIntegration(XSDataMOSFLMInput):
    subclass = None
    def __init__(self, imageEnd=None, imageStart=None, oscillationWidth=None, rotationAxisStart=None, beam=None, detector=None, directory=None, distance=None, matrix=None, mosaicity=None, symmetry=None, template=None, wavelength=None):
        XSDataMOSFLMInput.__init__(self, beam, detector, directory, distance, matrix, mosaicity, symmetry, template, wavelength)
        self.imageEnd = imageEnd
        self.imageStart = imageStart
        self.oscillationWidth = oscillationWidth
        self.rotationAxisStart = rotationAxisStart
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMInputIntegration.subclass:
            return XSDataMOSFLMInputIntegration.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMInputIntegration(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getImageEnd(self): return self.imageEnd
    def setImageEnd(self, imageEnd): self.imageEnd = imageEnd
    def getImageStart(self): return self.imageStart
    def setImageStart(self, imageStart): self.imageStart = imageStart
    def getOscillationWidth(self): return self.oscillationWidth
    def setOscillationWidth(self, oscillationWidth): self.oscillationWidth = oscillationWidth
    def getRotationAxisStart(self): return self.rotationAxisStart
    def setRotationAxisStart(self, rotationAxisStart): self.rotationAxisStart = rotationAxisStart
    def export(self, outfile, level, name_='XSDataMOSFLMInputIntegration'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputIntegration'):
        XSDataMOSFLMInput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputIntegration')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMInputIntegration'):
        if self.imageEnd:
            self.imageEnd.export(outfile, level, name_='imageEnd')
        if self.imageStart:
            self.imageStart.export(outfile, level, name_='imageStart')
        if self.oscillationWidth:
            self.oscillationWidth.export(outfile, level, name_='oscillationWidth')
        if self.rotationAxisStart:
            self.rotationAxisStart.export(outfile, level, name_='rotationAxisStart')
        XSDataMOSFLMInput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMInputIntegration' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputIntegration.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputIntegration.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMInputIntegration" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMInputIntegration'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMInput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.imageEnd:
            showIndent(outfile, level)
            outfile.write('imageEnd=XSDataInteger(\n')
            self.imageEnd.exportLiteral(outfile, level, name_='imageEnd')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.imageStart:
            showIndent(outfile, level)
            outfile.write('imageStart=XSDataInteger(\n')
            self.imageStart.exportLiteral(outfile, level, name_='imageStart')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.oscillationWidth:
            showIndent(outfile, level)
            outfile.write('oscillationWidth=XSDataAngle(\n')
            self.oscillationWidth.exportLiteral(outfile, level, name_='oscillationWidth')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.rotationAxisStart:
            showIndent(outfile, level)
            outfile.write('rotationAxisStart=XSDataAngle(\n')
            self.rotationAxisStart.exportLiteral(outfile, level, name_='rotationAxisStart')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataMOSFLMInput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMInput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'imageEnd':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setImageEnd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'imageStart':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setImageStart(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'oscillationWidth':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setOscillationWidth(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rotationAxisStart':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setRotationAxisStart(obj_)
        XSDataMOSFLMInput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMInputIntegration


class XSDataMOSFLMInputGeneratePrediction(XSDataMOSFLMInput):
    subclass = None
    def __init__(self, image=None, beam=None, detector=None, directory=None, distance=None, matrix=None, mosaicity=None, symmetry=None, template=None, wavelength=None):
        XSDataMOSFLMInput.__init__(self, beam, detector, directory, distance, matrix, mosaicity, symmetry, template, wavelength)
        self.image = image
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMInputGeneratePrediction.subclass:
            return XSDataMOSFLMInputGeneratePrediction.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMInputGeneratePrediction(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getImage(self): return self.image
    def setImage(self, image): self.image = image
    def export(self, outfile, level, name_='XSDataMOSFLMInputGeneratePrediction'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputGeneratePrediction'):
        XSDataMOSFLMInput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputGeneratePrediction')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMInputGeneratePrediction'):
        if self.image:
            self.image.export(outfile, level, name_='image')
        XSDataMOSFLMInput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMInputGeneratePrediction' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputGeneratePrediction.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputGeneratePrediction.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMInputGeneratePrediction" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMInputGeneratePrediction'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMInput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.image:
            showIndent(outfile, level)
            outfile.write('image=XSDataMOSFLMImage(\n')
            self.image.exportLiteral(outfile, level, name_='image')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataMOSFLMInput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMInput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'image':
            obj_ = XSDataMOSFLMImage.factory()
            obj_.build(child_)
            self.setImage(obj_)
        XSDataMOSFLMInput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMInputGeneratePrediction


class XSDataMOSFLMOutputIntegration(XSDataMOSFLMOutput):
    subclass = None
    def __init__(self, bestfileDat=None, bestfileHKL=None, bestfilePar=None, generatedMTZFile=None, highestResolutionIOverSigma=None, numberOfBadReflections=None, numberOfFullyRecordedReflections=None, numberOfNegativeReflections=None, numberOfOverlappedReflections=None, numberOfPartialReflections=None, numberOfReflectionsGenerated=None, overallIOverSigma=None, overallStatistics=None, refinedMosaicity=None, refinedYScale=None, RMSSpotDeviation=None, statisticsPerResolutionBin=None, refinedBeam=None, refinedDistance=None, refinedNewmat=None):
        XSDataMOSFLMOutput.__init__(self, refinedBeam, refinedDistance, refinedNewmat)
        self.bestfileDat = bestfileDat
        self.bestfileHKL = bestfileHKL
        self.bestfilePar = bestfilePar
        self.generatedMTZFile = generatedMTZFile
        self.highestResolutionIOverSigma = highestResolutionIOverSigma
        self.numberOfBadReflections = numberOfBadReflections
        self.numberOfFullyRecordedReflections = numberOfFullyRecordedReflections
        self.numberOfNegativeReflections = numberOfNegativeReflections
        self.numberOfOverlappedReflections = numberOfOverlappedReflections
        self.numberOfPartialReflections = numberOfPartialReflections
        self.numberOfReflectionsGenerated = numberOfReflectionsGenerated
        self.overallIOverSigma = overallIOverSigma
        self.overallStatistics = overallStatistics
        self.refinedMosaicity = refinedMosaicity
        self.refinedYScale = refinedYScale
        self.RMSSpotDeviation = RMSSpotDeviation
        if statisticsPerResolutionBin is None:
            self.statisticsPerResolutionBin = []
        else:
            self.statisticsPerResolutionBin = statisticsPerResolutionBin
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMOutputIntegration.subclass:
            return XSDataMOSFLMOutputIntegration.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMOutputIntegration(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBestfileDat(self): return self.bestfileDat
    def setBestfileDat(self, bestfileDat): self.bestfileDat = bestfileDat
    def getBestfileHKL(self): return self.bestfileHKL
    def setBestfileHKL(self, bestfileHKL): self.bestfileHKL = bestfileHKL
    def getBestfilePar(self): return self.bestfilePar
    def setBestfilePar(self, bestfilePar): self.bestfilePar = bestfilePar
    def getGeneratedMTZFile(self): return self.generatedMTZFile
    def setGeneratedMTZFile(self, generatedMTZFile): self.generatedMTZFile = generatedMTZFile
    def getHighestResolutionIOverSigma(self): return self.highestResolutionIOverSigma
    def setHighestResolutionIOverSigma(self, highestResolutionIOverSigma): self.highestResolutionIOverSigma = highestResolutionIOverSigma
    def getNumberOfBadReflections(self): return self.numberOfBadReflections
    def setNumberOfBadReflections(self, numberOfBadReflections): self.numberOfBadReflections = numberOfBadReflections
    def getNumberOfFullyRecordedReflections(self): return self.numberOfFullyRecordedReflections
    def setNumberOfFullyRecordedReflections(self, numberOfFullyRecordedReflections): self.numberOfFullyRecordedReflections = numberOfFullyRecordedReflections
    def getNumberOfNegativeReflections(self): return self.numberOfNegativeReflections
    def setNumberOfNegativeReflections(self, numberOfNegativeReflections): self.numberOfNegativeReflections = numberOfNegativeReflections
    def getNumberOfOverlappedReflections(self): return self.numberOfOverlappedReflections
    def setNumberOfOverlappedReflections(self, numberOfOverlappedReflections): self.numberOfOverlappedReflections = numberOfOverlappedReflections
    def getNumberOfPartialReflections(self): return self.numberOfPartialReflections
    def setNumberOfPartialReflections(self, numberOfPartialReflections): self.numberOfPartialReflections = numberOfPartialReflections
    def getNumberOfReflectionsGenerated(self): return self.numberOfReflectionsGenerated
    def setNumberOfReflectionsGenerated(self, numberOfReflectionsGenerated): self.numberOfReflectionsGenerated = numberOfReflectionsGenerated
    def getOverallIOverSigma(self): return self.overallIOverSigma
    def setOverallIOverSigma(self, overallIOverSigma): self.overallIOverSigma = overallIOverSigma
    def getOverallStatistics(self): return self.overallStatistics
    def setOverallStatistics(self, overallStatistics): self.overallStatistics = overallStatistics
    def getRefinedMosaicity(self): return self.refinedMosaicity
    def setRefinedMosaicity(self, refinedMosaicity): self.refinedMosaicity = refinedMosaicity
    def getRefinedYScale(self): return self.refinedYScale
    def setRefinedYScale(self, refinedYScale): self.refinedYScale = refinedYScale
    def getRMSSpotDeviation(self): return self.RMSSpotDeviation
    def setRMSSpotDeviation(self, RMSSpotDeviation): self.RMSSpotDeviation = RMSSpotDeviation
    def getStatisticsPerResolutionBin(self): return self.statisticsPerResolutionBin
    def setStatisticsPerResolutionBin(self, statisticsPerResolutionBin): self.statisticsPerResolutionBin = statisticsPerResolutionBin
    def addStatisticsPerResolutionBin(self, value): self.statisticsPerResolutionBin.append(value)
    def insertStatisticsPerResolutionBin(self, index, value): self.statisticsPerResolutionBin[index] = value
    def export(self, outfile, level, name_='XSDataMOSFLMOutputIntegration'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputIntegration'):
        XSDataMOSFLMOutput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputIntegration')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMOutputIntegration'):
        if self.bestfileDat:
            self.bestfileDat.export(outfile, level, name_='bestfileDat')
        if self.bestfileHKL:
            self.bestfileHKL.export(outfile, level, name_='bestfileHKL')
        if self.bestfilePar:
            self.bestfilePar.export(outfile, level, name_='bestfilePar')
        if self.generatedMTZFile:
            self.generatedMTZFile.export(outfile, level, name_='generatedMTZFile')
        if self.highestResolutionIOverSigma:
            self.highestResolutionIOverSigma.export(outfile, level, name_='highestResolutionIOverSigma')
        if self.numberOfBadReflections:
            self.numberOfBadReflections.export(outfile, level, name_='numberOfBadReflections')
        if self.numberOfFullyRecordedReflections:
            self.numberOfFullyRecordedReflections.export(outfile, level, name_='numberOfFullyRecordedReflections')
        if self.numberOfNegativeReflections:
            self.numberOfNegativeReflections.export(outfile, level, name_='numberOfNegativeReflections')
        if self.numberOfOverlappedReflections:
            self.numberOfOverlappedReflections.export(outfile, level, name_='numberOfOverlappedReflections')
        if self.numberOfPartialReflections:
            self.numberOfPartialReflections.export(outfile, level, name_='numberOfPartialReflections')
        if self.numberOfReflectionsGenerated:
            self.numberOfReflectionsGenerated.export(outfile, level, name_='numberOfReflectionsGenerated')
        if self.overallIOverSigma:
            self.overallIOverSigma.export(outfile, level, name_='overallIOverSigma')
        if self.overallStatistics:
            self.overallStatistics.export(outfile, level, name_='overallStatistics')
        if self.refinedMosaicity:
            self.refinedMosaicity.export(outfile, level, name_='refinedMosaicity')
        if self.refinedYScale:
            self.refinedYScale.export(outfile, level, name_='refinedYScale')
        if self.RMSSpotDeviation:
            self.RMSSpotDeviation.export(outfile, level, name_='RMSSpotDeviation')
        for statisticsPerResolutionBin_ in self.getStatisticsPerResolutionBin():
            statisticsPerResolutionBin_.export(outfile, level, name_='statisticsPerResolutionBin')
        XSDataMOSFLMOutput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMOutputIntegration' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputIntegration.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputIntegration.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMOutputIntegration" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMOutputIntegration'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMOutput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.bestfileDat:
            showIndent(outfile, level)
            outfile.write('bestfileDat=XSDataString(\n')
            self.bestfileDat.exportLiteral(outfile, level, name_='bestfileDat')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.bestfileHKL:
            showIndent(outfile, level)
            outfile.write('bestfileHKL=XSDataString(\n')
            self.bestfileHKL.exportLiteral(outfile, level, name_='bestfileHKL')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.bestfilePar:
            showIndent(outfile, level)
            outfile.write('bestfilePar=XSDataString(\n')
            self.bestfilePar.exportLiteral(outfile, level, name_='bestfilePar')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.generatedMTZFile:
            showIndent(outfile, level)
            outfile.write('generatedMTZFile=XSDataFile(\n')
            self.generatedMTZFile.exportLiteral(outfile, level, name_='generatedMTZFile')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.highestResolutionIOverSigma:
            showIndent(outfile, level)
            outfile.write('highestResolutionIOverSigma=XSDataFloat(\n')
            self.highestResolutionIOverSigma.exportLiteral(outfile, level, name_='highestResolutionIOverSigma')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfBadReflections:
            showIndent(outfile, level)
            outfile.write('numberOfBadReflections=XSDataInteger(\n')
            self.numberOfBadReflections.exportLiteral(outfile, level, name_='numberOfBadReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfFullyRecordedReflections:
            showIndent(outfile, level)
            outfile.write('numberOfFullyRecordedReflections=XSDataInteger(\n')
            self.numberOfFullyRecordedReflections.exportLiteral(outfile, level, name_='numberOfFullyRecordedReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfNegativeReflections:
            showIndent(outfile, level)
            outfile.write('numberOfNegativeReflections=XSDataInteger(\n')
            self.numberOfNegativeReflections.exportLiteral(outfile, level, name_='numberOfNegativeReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfOverlappedReflections:
            showIndent(outfile, level)
            outfile.write('numberOfOverlappedReflections=XSDataInteger(\n')
            self.numberOfOverlappedReflections.exportLiteral(outfile, level, name_='numberOfOverlappedReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfPartialReflections:
            showIndent(outfile, level)
            outfile.write('numberOfPartialReflections=XSDataInteger(\n')
            self.numberOfPartialReflections.exportLiteral(outfile, level, name_='numberOfPartialReflections')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOfReflectionsGenerated:
            showIndent(outfile, level)
            outfile.write('numberOfReflectionsGenerated=XSDataInteger(\n')
            self.numberOfReflectionsGenerated.exportLiteral(outfile, level, name_='numberOfReflectionsGenerated')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.overallIOverSigma:
            showIndent(outfile, level)
            outfile.write('overallIOverSigma=XSDataFloat(\n')
            self.overallIOverSigma.exportLiteral(outfile, level, name_='overallIOverSigma')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.overallStatistics:
            showIndent(outfile, level)
            outfile.write('overallStatistics=XSDataMOSFLMIntegrationStatisticsPerResolutionBin(\n')
            self.overallStatistics.exportLiteral(outfile, level, name_='overallStatistics')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.refinedMosaicity:
            showIndent(outfile, level)
            outfile.write('refinedMosaicity=XSDataFloat(\n')
            self.refinedMosaicity.exportLiteral(outfile, level, name_='refinedMosaicity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.refinedYScale:
            showIndent(outfile, level)
            outfile.write('refinedYScale=XSDataFloat(\n')
            self.refinedYScale.exportLiteral(outfile, level, name_='refinedYScale')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.RMSSpotDeviation:
            showIndent(outfile, level)
            outfile.write('RMSSpotDeviation=XSDataLength(\n')
            self.RMSSpotDeviation.exportLiteral(outfile, level, name_='RMSSpotDeviation')
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('statisticsPerResolutionBin=[\n')
        level += 1
        for statisticsPerResolutionBin in self.statisticsPerResolutionBin:
            showIndent(outfile, level)
            outfile.write('XSDataMOSFLMIntegrationStatisticsPerResolutionBin(\n')
            statisticsPerResolutionBin.exportLiteral(outfile, level, name_='statisticsPerResolutionBin')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        XSDataMOSFLMOutput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMOutput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bestfileDat':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setBestfileDat(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bestfileHKL':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setBestfileHKL(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bestfilePar':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setBestfilePar(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'generatedMTZFile':
            obj_ = XSDataFile.factory()
            obj_.build(child_)
            self.setGeneratedMTZFile(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'highestResolutionIOverSigma':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setHighestResolutionIOverSigma(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfBadReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfBadReflections(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfFullyRecordedReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfFullyRecordedReflections(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfNegativeReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfNegativeReflections(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfOverlappedReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfOverlappedReflections(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfPartialReflections':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfPartialReflections(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfReflectionsGenerated':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOfReflectionsGenerated(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'overallIOverSigma':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setOverallIOverSigma(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'overallStatistics':
            obj_ = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
            obj_.build(child_)
            self.setOverallStatistics(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedMosaicity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setRefinedMosaicity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refinedYScale':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setRefinedYScale(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RMSSpotDeviation':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setRMSSpotDeviation(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'statisticsPerResolutionBin':
            obj_ = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
            obj_.build(child_)
            self.statisticsPerResolutionBin.append(obj_)
        XSDataMOSFLMOutput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMOutputIntegration


class XSDataMOSFLMOutputIndexing(XSDataMOSFLMOutput):
    subclass = None
    def __init__(self, beamShift=None, deviationAngular=None, deviationPositional=None, mosaicityEstimation=None, possibleSolutions=None, selectedSolutionNumber=None, selectedSolutionSpaceGroup=None, selectedSolutionSpaceGroupNumber=None, spotsTotal=None, spotsUsed=None, refinedBeam=None, refinedDistance=None, refinedNewmat=None):
        XSDataMOSFLMOutput.__init__(self, refinedBeam, refinedDistance, refinedNewmat)
        self.beamShift = beamShift
        self.deviationAngular = deviationAngular
        self.deviationPositional = deviationPositional
        self.mosaicityEstimation = mosaicityEstimation
        if possibleSolutions is None:
            self.possibleSolutions = []
        else:
            self.possibleSolutions = possibleSolutions
        self.selectedSolutionNumber = selectedSolutionNumber
        self.selectedSolutionSpaceGroup = selectedSolutionSpaceGroup
        self.selectedSolutionSpaceGroupNumber = selectedSolutionSpaceGroupNumber
        self.spotsTotal = spotsTotal
        self.spotsUsed = spotsUsed
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMOutputIndexing.subclass:
            return XSDataMOSFLMOutputIndexing.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMOutputIndexing(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBeamShift(self): return self.beamShift
    def setBeamShift(self, beamShift): self.beamShift = beamShift
    def getDeviationAngular(self): return self.deviationAngular
    def setDeviationAngular(self, deviationAngular): self.deviationAngular = deviationAngular
    def getDeviationPositional(self): return self.deviationPositional
    def setDeviationPositional(self, deviationPositional): self.deviationPositional = deviationPositional
    def getMosaicityEstimation(self): return self.mosaicityEstimation
    def setMosaicityEstimation(self, mosaicityEstimation): self.mosaicityEstimation = mosaicityEstimation
    def getPossibleSolutions(self): return self.possibleSolutions
    def setPossibleSolutions(self, possibleSolutions): self.possibleSolutions = possibleSolutions
    def addPossibleSolutions(self, value): self.possibleSolutions.append(value)
    def insertPossibleSolutions(self, index, value): self.possibleSolutions[index] = value
    def getSelectedSolutionNumber(self): return self.selectedSolutionNumber
    def setSelectedSolutionNumber(self, selectedSolutionNumber): self.selectedSolutionNumber = selectedSolutionNumber
    def getSelectedSolutionSpaceGroup(self): return self.selectedSolutionSpaceGroup
    def setSelectedSolutionSpaceGroup(self, selectedSolutionSpaceGroup): self.selectedSolutionSpaceGroup = selectedSolutionSpaceGroup
    def getSelectedSolutionSpaceGroupNumber(self): return self.selectedSolutionSpaceGroupNumber
    def setSelectedSolutionSpaceGroupNumber(self, selectedSolutionSpaceGroupNumber): self.selectedSolutionSpaceGroupNumber = selectedSolutionSpaceGroupNumber
    def getSpotsTotal(self): return self.spotsTotal
    def setSpotsTotal(self, spotsTotal): self.spotsTotal = spotsTotal
    def getSpotsUsed(self): return self.spotsUsed
    def setSpotsUsed(self, spotsUsed): self.spotsUsed = spotsUsed
    def export(self, outfile, level, name_='XSDataMOSFLMOutputIndexing'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputIndexing'):
        XSDataMOSFLMOutput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMOutputIndexing')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMOutputIndexing'):
        if self.beamShift:
            self.beamShift.export(outfile, level, name_='beamShift')
        if self.deviationAngular:
            self.deviationAngular.export(outfile, level, name_='deviationAngular')
        if self.deviationPositional:
            self.deviationPositional.export(outfile, level, name_='deviationPositional')
        if self.mosaicityEstimation:
            self.mosaicityEstimation.export(outfile, level, name_='mosaicityEstimation')
        for possibleSolutions_ in self.getPossibleSolutions():
            possibleSolutions_.export(outfile, level, name_='possibleSolutions')
        if self.selectedSolutionNumber:
            self.selectedSolutionNumber.export(outfile, level, name_='selectedSolutionNumber')
        if self.selectedSolutionSpaceGroup:
            self.selectedSolutionSpaceGroup.export(outfile, level, name_='selectedSolutionSpaceGroup')
        if self.selectedSolutionSpaceGroupNumber:
            self.selectedSolutionSpaceGroupNumber.export(outfile, level, name_='selectedSolutionSpaceGroupNumber')
        if self.spotsTotal:
            self.spotsTotal.export(outfile, level, name_='spotsTotal')
        if self.spotsUsed:
            self.spotsUsed.export(outfile, level, name_='spotsUsed')
        XSDataMOSFLMOutput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMOutputIndexing' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputIndexing.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMOutputIndexing.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMOutputIndexing" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMOutputIndexing'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMOutput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.beamShift:
            showIndent(outfile, level)
            outfile.write('beamShift=XSDataMOSFLMBeamPosition(\n')
            self.beamShift.exportLiteral(outfile, level, name_='beamShift')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.deviationAngular:
            showIndent(outfile, level)
            outfile.write('deviationAngular=XSDataAngle(\n')
            self.deviationAngular.exportLiteral(outfile, level, name_='deviationAngular')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.deviationPositional:
            showIndent(outfile, level)
            outfile.write('deviationPositional=XSDataLength(\n')
            self.deviationPositional.exportLiteral(outfile, level, name_='deviationPositional')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.mosaicityEstimation:
            showIndent(outfile, level)
            outfile.write('mosaicityEstimation=XSDataFloat(\n')
            self.mosaicityEstimation.exportLiteral(outfile, level, name_='mosaicityEstimation')
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('possibleSolutions=[\n')
        level += 1
        for possibleSolutions in self.possibleSolutions:
            showIndent(outfile, level)
            outfile.write('XSDataMOSFLMIndexingSolution(\n')
            possibleSolutions.exportLiteral(outfile, level, name_='possibleSolutions')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.selectedSolutionNumber:
            showIndent(outfile, level)
            outfile.write('selectedSolutionNumber=XSDataInteger(\n')
            self.selectedSolutionNumber.exportLiteral(outfile, level, name_='selectedSolutionNumber')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.selectedSolutionSpaceGroup:
            showIndent(outfile, level)
            outfile.write('selectedSolutionSpaceGroup=XSDataString(\n')
            self.selectedSolutionSpaceGroup.exportLiteral(outfile, level, name_='selectedSolutionSpaceGroup')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.selectedSolutionSpaceGroupNumber:
            showIndent(outfile, level)
            outfile.write('selectedSolutionSpaceGroupNumber=XSDataInteger(\n')
            self.selectedSolutionSpaceGroupNumber.exportLiteral(outfile, level, name_='selectedSolutionSpaceGroupNumber')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.spotsTotal:
            showIndent(outfile, level)
            outfile.write('spotsTotal=XSDataInteger(\n')
            self.spotsTotal.exportLiteral(outfile, level, name_='spotsTotal')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.spotsUsed:
            showIndent(outfile, level)
            outfile.write('spotsUsed=XSDataInteger(\n')
            self.spotsUsed.exportLiteral(outfile, level, name_='spotsUsed')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataMOSFLMOutput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMOutput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'beamShift':
            obj_ = XSDataMOSFLMBeamPosition.factory()
            obj_.build(child_)
            self.setBeamShift(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'deviationAngular':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setDeviationAngular(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'deviationPositional':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setDeviationPositional(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mosaicityEstimation':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setMosaicityEstimation(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'possibleSolutions':
            obj_ = XSDataMOSFLMIndexingSolution.factory()
            obj_.build(child_)
            self.possibleSolutions.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'selectedSolutionNumber':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setSelectedSolutionNumber(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'selectedSolutionSpaceGroup':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setSelectedSolutionSpaceGroup(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'selectedSolutionSpaceGroupNumber':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setSelectedSolutionSpaceGroupNumber(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spotsTotal':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setSpotsTotal(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spotsUsed':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setSpotsUsed(obj_)
        XSDataMOSFLMOutput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMOutputIndexing


class XSDataMOSFLMInputPostRefinement(XSDataMOSFLMInput):
    subclass = None
    def __init__(self, beam=None, detector=None, directory=None, distance=None, matrix=None, mosaicity=None, symmetry=None, template=None, wavelength=None, valueOf_=''):
        XSDataMOSFLMInput.__init__(self, beam, detector, directory, distance, matrix, mosaicity, symmetry, template, wavelength)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if XSDataMOSFLMInputPostRefinement.subclass:
            return XSDataMOSFLMInputPostRefinement.subclass(*args_, **kwargs_)
        else:
            return XSDataMOSFLMInputPostRefinement(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='XSDataMOSFLMInputPostRefinement'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputPostRefinement'):
        XSDataMOSFLMInput.exportAttributes(self, outfile, level, name_='XSDataMOSFLMInputPostRefinement')
    def exportChildren(self, outfile, level, name_='XSDataMOSFLMInputPostRefinement'):
        XSDataMOSFLMInput.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataMOSFLMInputPostRefinement' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputPostRefinement.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataMOSFLMInputPostRefinement.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataMOSFLMInputPostRefinement" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataMOSFLMInputPostRefinement'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataMOSFLMInput.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
        XSDataMOSFLMInput.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataMOSFLMInput.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        XSDataMOSFLMInput.buildChildren(self, child_, nodeName_)
# end class XSDataMOSFLMInputPostRefinement


class XSDataTime(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataTime.subclass:
            return XSDataTime.subclass(*args_, **kwargs_)
        else:
            return XSDataTime(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataTime'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataTime'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataTime')
    def exportChildren(self, outfile, level, name_='XSDataTime'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataTime' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataTime.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataTime.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataTime" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataTime'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataTime


class XSDataDetector(XSData):
    subclass = None
    def __init__(self, beamPositionX=None, beamPositionY=None, bin=None, byteOrder=None, dataType=None, distance=None, gain=None, imageSaturation=None, name=None, numberBytesInHeader=None, numberPixelX=None, numberPixelY=None, pixelSizeX=None, pixelSizeY=None, serialNumber=None, twoTheta=None, typexx=None):
        XSData.__init__(self)
        self.beamPositionX = beamPositionX
        self.beamPositionY = beamPositionY
        self.bin = bin
        self.byteOrder = byteOrder
        self.dataType = dataType
        self.distance = distance
        self.gain = gain
        self.imageSaturation = imageSaturation
        self.name = name
        self.numberBytesInHeader = numberBytesInHeader
        self.numberPixelX = numberPixelX
        self.numberPixelY = numberPixelY
        self.pixelSizeX = pixelSizeX
        self.pixelSizeY = pixelSizeY
        self.serialNumber = serialNumber
        self.twoTheta = twoTheta
        self.typexx = typexx
    def factory(*args_, **kwargs_):
        if XSDataDetector.subclass:
            return XSDataDetector.subclass(*args_, **kwargs_)
        else:
            return XSDataDetector(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBeamPositionX(self): return self.beamPositionX
    def setBeamPositionX(self, beamPositionX): self.beamPositionX = beamPositionX
    def getBeamPositionY(self): return self.beamPositionY
    def setBeamPositionY(self, beamPositionY): self.beamPositionY = beamPositionY
    def getBin(self): return self.bin
    def setBin(self, bin): self.bin = bin
    def getByteOrder(self): return self.byteOrder
    def setByteOrder(self, byteOrder): self.byteOrder = byteOrder
    def getDataType(self): return self.dataType
    def setDataType(self, dataType): self.dataType = dataType
    def getDistance(self): return self.distance
    def setDistance(self, distance): self.distance = distance
    def getGain(self): return self.gain
    def setGain(self, gain): self.gain = gain
    def getImageSaturation(self): return self.imageSaturation
    def setImageSaturation(self, imageSaturation): self.imageSaturation = imageSaturation
    def getName(self): return self.name
    def setName(self, name): self.name = name
    def getNumberBytesInHeader(self): return self.numberBytesInHeader
    def setNumberBytesInHeader(self, numberBytesInHeader): self.numberBytesInHeader = numberBytesInHeader
    def getNumberPixelX(self): return self.numberPixelX
    def setNumberPixelX(self, numberPixelX): self.numberPixelX = numberPixelX
    def getNumberPixelY(self): return self.numberPixelY
    def setNumberPixelY(self, numberPixelY): self.numberPixelY = numberPixelY
    def getPixelSizeX(self): return self.pixelSizeX
    def setPixelSizeX(self, pixelSizeX): self.pixelSizeX = pixelSizeX
    def getPixelSizeY(self): return self.pixelSizeY
    def setPixelSizeY(self, pixelSizeY): self.pixelSizeY = pixelSizeY
    def getSerialNumber(self): return self.serialNumber
    def setSerialNumber(self, serialNumber): self.serialNumber = serialNumber
    def getTwoTheta(self): return self.twoTheta
    def setTwoTheta(self, twoTheta): self.twoTheta = twoTheta
    def getType(self): return self.typexx
    def setType(self, typexx): self.typexx = typexx
    def export(self, outfile, level, name_='XSDataDetector'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataDetector'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataDetector')
    def exportChildren(self, outfile, level, name_='XSDataDetector'):
        if self.beamPositionX:
            self.beamPositionX.export(outfile, level, name_='beamPositionX')
        if self.beamPositionY:
            self.beamPositionY.export(outfile, level, name_='beamPositionY')
        if self.bin:
            self.bin.export(outfile, level, name_='bin')
        if self.byteOrder:
            self.byteOrder.export(outfile, level, name_='byteOrder')
        if self.dataType:
            self.dataType.export(outfile, level, name_='dataType')
        if self.distance:
            self.distance.export(outfile, level, name_='distance')
        if self.gain:
            self.gain.export(outfile, level, name_='gain')
        if self.imageSaturation:
            self.imageSaturation.export(outfile, level, name_='imageSaturation')
        if self.name:
            self.name.export(outfile, level, name_='name')
        if self.numberBytesInHeader:
            self.numberBytesInHeader.export(outfile, level, name_='numberBytesInHeader')
        if self.numberPixelX:
            self.numberPixelX.export(outfile, level, name_='numberPixelX')
        if self.numberPixelY:
            self.numberPixelY.export(outfile, level, name_='numberPixelY')
        if self.pixelSizeX:
            self.pixelSizeX.export(outfile, level, name_='pixelSizeX')
        if self.pixelSizeY:
            self.pixelSizeY.export(outfile, level, name_='pixelSizeY')
        if self.serialNumber:
            self.serialNumber.export(outfile, level, name_='serialNumber')
        if self.twoTheta:
            self.twoTheta.export(outfile, level, name_='twoTheta')
        if self.typexx:
            self.typexx.export(outfile, level, name_='type')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataDetector' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataDetector.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataDetector.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataDetector" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataDetector'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.beamPositionX:
            showIndent(outfile, level)
            outfile.write('beamPositionX=XSDataLength(\n')
            self.beamPositionX.exportLiteral(outfile, level, name_='beamPositionX')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.beamPositionY:
            showIndent(outfile, level)
            outfile.write('beamPositionY=XSDataLength(\n')
            self.beamPositionY.exportLiteral(outfile, level, name_='beamPositionY')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.bin:
            showIndent(outfile, level)
            outfile.write('bin=XSDataString(\n')
            self.bin.exportLiteral(outfile, level, name_='bin')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.byteOrder:
            showIndent(outfile, level)
            outfile.write('byteOrder=XSDataString(\n')
            self.byteOrder.exportLiteral(outfile, level, name_='byteOrder')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.dataType:
            showIndent(outfile, level)
            outfile.write('dataType=XSDataString(\n')
            self.dataType.exportLiteral(outfile, level, name_='dataType')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.distance:
            showIndent(outfile, level)
            outfile.write('distance=XSDataLength(\n')
            self.distance.exportLiteral(outfile, level, name_='distance')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.gain:
            showIndent(outfile, level)
            outfile.write('gain=XSDataFloat(\n')
            self.gain.exportLiteral(outfile, level, name_='gain')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.imageSaturation:
            showIndent(outfile, level)
            outfile.write('imageSaturation=XSDataInteger(\n')
            self.imageSaturation.exportLiteral(outfile, level, name_='imageSaturation')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.name:
            showIndent(outfile, level)
            outfile.write('name=XSDataString(\n')
            self.name.exportLiteral(outfile, level, name_='name')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberBytesInHeader:
            showIndent(outfile, level)
            outfile.write('numberBytesInHeader=XSDataInteger(\n')
            self.numberBytesInHeader.exportLiteral(outfile, level, name_='numberBytesInHeader')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberPixelX:
            showIndent(outfile, level)
            outfile.write('numberPixelX=XSDataInteger(\n')
            self.numberPixelX.exportLiteral(outfile, level, name_='numberPixelX')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberPixelY:
            showIndent(outfile, level)
            outfile.write('numberPixelY=XSDataInteger(\n')
            self.numberPixelY.exportLiteral(outfile, level, name_='numberPixelY')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.pixelSizeX:
            showIndent(outfile, level)
            outfile.write('pixelSizeX=XSDataFloat(\n')
            self.pixelSizeX.exportLiteral(outfile, level, name_='pixelSizeX')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.pixelSizeY:
            showIndent(outfile, level)
            outfile.write('pixelSizeY=XSDataFloat(\n')
            self.pixelSizeY.exportLiteral(outfile, level, name_='pixelSizeY')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.serialNumber:
            showIndent(outfile, level)
            outfile.write('serialNumber=XSDataString(\n')
            self.serialNumber.exportLiteral(outfile, level, name_='serialNumber')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.twoTheta:
            showIndent(outfile, level)
            outfile.write('twoTheta=XSDataAngle(\n')
            self.twoTheta.exportLiteral(outfile, level, name_='twoTheta')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.typexx:
            showIndent(outfile, level)
            outfile.write('typexx=XSDataString(\n')
            self.typexx.exportLiteral(outfile, level, name_='type')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'beamPositionX':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setBeamPositionX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'beamPositionY':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setBeamPositionY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bin':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setBin(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'byteOrder':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setByteOrder(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dataType':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setDataType(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'distance':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setDistance(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gain':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setGain(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'imageSaturation':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setImageSaturation(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setName(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberBytesInHeader':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberBytesInHeader(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberPixelX':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberPixelX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberPixelY':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberPixelY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pixelSizeX':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setPixelSizeX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pixelSizeY':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setPixelSizeY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'serialNumber':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setSerialNumber(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'twoTheta':
            obj_ = XSDataAngle.factory()
            obj_.build(child_)
            self.setTwoTheta(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setType(obj_)
# end class XSDataDetector


class XSDataAngle(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataAngle.subclass:
            return XSDataAngle.subclass(*args_, **kwargs_)
        else:
            return XSDataAngle(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataAngle'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataAngle'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataAngle')
    def exportChildren(self, outfile, level, name_='XSDataAngle'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataAngle' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataAngle.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataAngle.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataAngle" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataAngle'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataAngle


class XSDataSize(XSData):
    subclass = None
    def __init__(self, x=None, y=None, z=None):
        XSData.__init__(self)
        self.x = x
        self.y = y
        self.z = z
    def factory(*args_, **kwargs_):
        if XSDataSize.subclass:
            return XSDataSize.subclass(*args_, **kwargs_)
        else:
            return XSDataSize(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getX(self): return self.x
    def setX(self, x): self.x = x
    def getY(self): return self.y
    def setY(self, y): self.y = y
    def getZ(self): return self.z
    def setZ(self, z): self.z = z
    def export(self, outfile, level, name_='XSDataSize'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSize'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSize')
    def exportChildren(self, outfile, level, name_='XSDataSize'):
        if self.x:
            self.x.export(outfile, level, name_='x')
        if self.y:
            self.y.export(outfile, level, name_='y')
        if self.z:
            self.z.export(outfile, level, name_='z')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSize' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSize.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSize.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSize" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSize'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.x:
            showIndent(outfile, level)
            outfile.write('x=XSDataLength(\n')
            self.x.exportLiteral(outfile, level, name_='x')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.y:
            showIndent(outfile, level)
            outfile.write('y=XSDataLength(\n')
            self.y.exportLiteral(outfile, level, name_='y')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.z:
            showIndent(outfile, level)
            outfile.write('z=XSDataLength(\n')
            self.z.exportLiteral(outfile, level, name_='z')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'x':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setX(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'y':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setY(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'z':
            obj_ = XSDataLength.factory()
            obj_.build(child_)
            self.setZ(obj_)
# end class XSDataSize


class XSDataStructure(XSData):
    subclass = None
    def __init__(self, chain=None, ligand=None, numberOfCopiesInAsymmetricUnit=None):
        XSData.__init__(self)
        if chain is None:
            self.chain = []
        else:
            self.chain = chain
        if ligand is None:
            self.ligand = []
        else:
            self.ligand = ligand
        self.numberOfCopiesInAsymmetricUnit = numberOfCopiesInAsymmetricUnit
    def factory(*args_, **kwargs_):
        if XSDataStructure.subclass:
            return XSDataStructure.subclass(*args_, **kwargs_)
        else:
            return XSDataStructure(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getChain(self): return self.chain
    def setChain(self, chain): self.chain = chain
    def addChain(self, value): self.chain.append(value)
    def insertChain(self, index, value): self.chain[index] = value
    def getLigand(self): return self.ligand
    def setLigand(self, ligand): self.ligand = ligand
    def addLigand(self, value): self.ligand.append(value)
    def insertLigand(self, index, value): self.ligand[index] = value
    def getNumberOfCopiesInAsymmetricUnit(self): return self.numberOfCopiesInAsymmetricUnit
    def setNumberOfCopiesInAsymmetricUnit(self, numberOfCopiesInAsymmetricUnit): self.numberOfCopiesInAsymmetricUnit = numberOfCopiesInAsymmetricUnit
    def export(self, outfile, level, name_='XSDataStructure'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataStructure'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataStructure')
    def exportChildren(self, outfile, level, name_='XSDataStructure'):
        for chain_ in self.getChain():
            chain_.export(outfile, level, name_='chain')
        for ligand_ in self.getLigand():
            ligand_.export(outfile, level, name_='ligand')
        if self.numberOfCopiesInAsymmetricUnit:
            self.numberOfCopiesInAsymmetricUnit.export(outfile, level, name_='numberOfCopiesInAsymmetricUnit')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataStructure' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataStructure.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataStructure.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataStructure" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataStructure'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('chain=[\n')
        level += 1
        for chain in self.chain:
            showIndent(outfile, level)
            outfile.write('XSDataChain(\n')
            chain.exportLiteral(outfile, level, name_='chain')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('ligand=[\n')
        level += 1
        for ligand in self.ligand:
            showIndent(outfile, level)
            outfile.write('XSDataLigand(\n')
            ligand.exportLiteral(outfile, level, name_='ligand')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.numberOfCopiesInAsymmetricUnit:
            showIndent(outfile, level)
            outfile.write('numberOfCopiesInAsymmetricUnit=XSDataFloat(\n')
            self.numberOfCopiesInAsymmetricUnit.exportLiteral(outfile, level, name_='numberOfCopiesInAsymmetricUnit')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'chain':
            obj_ = XSDataChain.factory()
            obj_.build(child_)
            self.chain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ligand':
            obj_ = XSDataLigand.factory()
            obj_.build(child_)
            self.ligand.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOfCopiesInAsymmetricUnit':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setNumberOfCopiesInAsymmetricUnit(obj_)
# end class XSDataStructure


class XSDataFloat(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataFloat.subclass:
            return XSDataFloat.subclass(*args_, **kwargs_)
        else:
            return XSDataFloat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataFloat'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataFloat'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataFloat')
    def exportChildren(self, outfile, level, name_='XSDataFloat'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataFloat' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataFloat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataFloat.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataFloat" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataFloat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataFloat


class XSDataSpeed(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataSpeed.subclass:
            return XSDataSpeed.subclass(*args_, **kwargs_)
        else:
            return XSDataSpeed(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataSpeed'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSpeed'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSpeed')
    def exportChildren(self, outfile, level, name_='XSDataSpeed'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSpeed' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSpeed.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSpeed.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSpeed" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSpeed'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataSpeed


class XSDataFlux(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataFlux.subclass:
            return XSDataFlux.subclass(*args_, **kwargs_)
        else:
            return XSDataFlux(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataFlux'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataFlux'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataFlux')
    def exportChildren(self, outfile, level, name_='XSDataFlux'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataFlux' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataFlux.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataFlux.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataFlux" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataFlux'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataFlux


class XSDataExperimentalCondition(XSData):
    subclass = None
    def __init__(self, beam=None, detector=None, goniostat=None):
        XSData.__init__(self)
        self.beam = beam
        self.detector = detector
        self.goniostat = goniostat
    def factory(*args_, **kwargs_):
        if XSDataExperimentalCondition.subclass:
            return XSDataExperimentalCondition.subclass(*args_, **kwargs_)
        else:
            return XSDataExperimentalCondition(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBeam(self): return self.beam
    def setBeam(self, beam): self.beam = beam
    def getDetector(self): return self.detector
    def setDetector(self, detector): self.detector = detector
    def getGoniostat(self): return self.goniostat
    def setGoniostat(self, goniostat): self.goniostat = goniostat
    def export(self, outfile, level, name_='XSDataExperimentalCondition'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataExperimentalCondition'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataExperimentalCondition')
    def exportChildren(self, outfile, level, name_='XSDataExperimentalCondition'):
        if self.beam:
            self.beam.export(outfile, level, name_='beam')
        if self.detector:
            self.detector.export(outfile, level, name_='detector')
        if self.goniostat:
            self.goniostat.export(outfile, level, name_='goniostat')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataExperimentalCondition' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataExperimentalCondition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataExperimentalCondition.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataExperimentalCondition" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataExperimentalCondition'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.beam:
            showIndent(outfile, level)
            outfile.write('beam=XSDataBeam(\n')
            self.beam.exportLiteral(outfile, level, name_='beam')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.detector:
            showIndent(outfile, level)
            outfile.write('detector=XSDataDetector(\n')
            self.detector.exportLiteral(outfile, level, name_='detector')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.goniostat:
            showIndent(outfile, level)
            outfile.write('goniostat=XSDataGoniostat(\n')
            self.goniostat.exportLiteral(outfile, level, name_='goniostat')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'beam':
            obj_ = XSDataBeam.factory()
            obj_.build(child_)
            self.setBeam(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'detector':
            obj_ = XSDataDetector.factory()
            obj_.build(child_)
            self.setDetector(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'goniostat':
            obj_ = XSDataGoniostat.factory()
            obj_.build(child_)
            self.setGoniostat(obj_)
# end class XSDataExperimentalCondition


class XSDataInteger(XSData):
    subclass = None
    def __init__(self, value=-1):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataInteger.subclass:
            return XSDataInteger.subclass(*args_, **kwargs_)
        else:
            return XSDataInteger(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataInteger'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataInteger'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataInteger')
    def exportChildren(self, outfile, level, name_='XSDataInteger'):
        showIndent(outfile, level)
        outfile.write('<value>%d</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataInteger' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataInteger.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataInteger.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataInteger" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataInteger'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%d,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.value = ival_
# end class XSDataInteger


class XSDataBeam(XSData):
    subclass = None
    def __init__(self, exposureTime=None, flux=None, minExposureTimePerImage=None, size=None, wavelength=None):
        XSData.__init__(self)
        self.exposureTime = exposureTime
        self.flux = flux
        self.minExposureTimePerImage = minExposureTimePerImage
        self.size = size
        self.wavelength = wavelength
    def factory(*args_, **kwargs_):
        if XSDataBeam.subclass:
            return XSDataBeam.subclass(*args_, **kwargs_)
        else:
            return XSDataBeam(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getExposureTime(self): return self.exposureTime
    def setExposureTime(self, exposureTime): self.exposureTime = exposureTime
    def getFlux(self): return self.flux
    def setFlux(self, flux): self.flux = flux
    def getMinExposureTimePerImage(self): return self.minExposureTimePerImage
    def setMinExposureTimePerImage(self, minExposureTimePerImage): self.minExposureTimePerImage = minExposureTimePerImage
    def getSize(self): return self.size
    def setSize(self, size): self.size = size
    def getWavelength(self): return self.wavelength
    def setWavelength(self, wavelength): self.wavelength = wavelength
    def export(self, outfile, level, name_='XSDataBeam'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataBeam'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataBeam')
    def exportChildren(self, outfile, level, name_='XSDataBeam'):
        if self.exposureTime:
            self.exposureTime.export(outfile, level, name_='exposureTime')
        if self.flux:
            self.flux.export(outfile, level, name_='flux')
        if self.minExposureTimePerImage:
            self.minExposureTimePerImage.export(outfile, level, name_='minExposureTimePerImage')
        if self.size:
            self.size.export(outfile, level, name_='size')
        if self.wavelength:
            self.wavelength.export(outfile, level, name_='wavelength')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataBeam' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataBeam.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataBeam.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataBeam" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataBeam'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.exposureTime:
            showIndent(outfile, level)
            outfile.write('exposureTime=XSDataTime(\n')
            self.exposureTime.exportLiteral(outfile, level, name_='exposureTime')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.flux:
            showIndent(outfile, level)
            outfile.write('flux=XSDataFlux(\n')
            self.flux.exportLiteral(outfile, level, name_='flux')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.minExposureTimePerImage:
            showIndent(outfile, level)
            outfile.write('minExposureTimePerImage=XSDataTime(\n')
            self.minExposureTimePerImage.exportLiteral(outfile, level, name_='minExposureTimePerImage')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.size:
            showIndent(outfile, level)
            outfile.write('size=XSDataSize(\n')
            self.size.exportLiteral(outfile, level, name_='size')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.wavelength:
            showIndent(outfile, level)
            outfile.write('wavelength=XSDataWavelength(\n')
            self.wavelength.exportLiteral(outfile, level, name_='wavelength')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'exposureTime':
            obj_ = XSDataTime.factory()
            obj_.build(child_)
            self.setExposureTime(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'flux':
            obj_ = XSDataFlux.factory()
            obj_.build(child_)
            self.setFlux(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'minExposureTimePerImage':
            obj_ = XSDataTime.factory()
            obj_.build(child_)
            self.setMinExposureTimePerImage(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'size':
            obj_ = XSDataSize.factory()
            obj_.build(child_)
            self.setSize(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'wavelength':
            obj_ = XSDataWavelength.factory()
            obj_.build(child_)
            self.setWavelength(obj_)
# end class XSDataBeam


class XSDataString(XSData):
    subclass = None
    def __init__(self, value=''):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataString.subclass:
            return XSDataString.subclass(*args_, **kwargs_)
        else:
            return XSDataString(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataString'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataString'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataString')
    def exportChildren(self, outfile, level, name_='XSDataString'):
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataString' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataString.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataString.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataString" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataString'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%s,\n' % quote_python(self.getValue()))
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class XSDataString


class XSDataFile(XSData):
    subclass = None
    def __init__(self, path=None):
        XSData.__init__(self)
        self.path = path
    def factory(*args_, **kwargs_):
        if XSDataFile.subclass:
            return XSDataFile.subclass(*args_, **kwargs_)
        else:
            return XSDataFile(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPath(self): return self.path
    def setPath(self, path): self.path = path
    def export(self, outfile, level, name_='XSDataFile'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataFile'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataFile')
    def exportChildren(self, outfile, level, name_='XSDataFile'):
        if self.path:
            self.path.export(outfile, level, name_='path')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataFile' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataFile.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataFile.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataFile" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataFile'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.path:
            showIndent(outfile, level)
            outfile.write('path=XSDataString(\n')
            self.path.exportLiteral(outfile, level, name_='path')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'path':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setPath(obj_)
# end class XSDataFile


class XSDataLength(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataLength.subclass:
            return XSDataLength.subclass(*args_, **kwargs_)
        else:
            return XSDataLength(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataLength'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataLength'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataLength')
    def exportChildren(self, outfile, level, name_='XSDataLength'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataLength' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataLength.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataLength.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataLength" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataLength'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataLength


class XSDataAbsorbedDoseRate(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataAbsorbedDoseRate.subclass:
            return XSDataAbsorbedDoseRate.subclass(*args_, **kwargs_)
        else:
            return XSDataAbsorbedDoseRate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataAbsorbedDoseRate'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataAbsorbedDoseRate'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataAbsorbedDoseRate')
    def exportChildren(self, outfile, level, name_='XSDataAbsorbedDoseRate'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataAbsorbedDoseRate' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataAbsorbedDoseRate.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataAbsorbedDoseRate.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataAbsorbedDoseRate" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataAbsorbedDoseRate'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataAbsorbedDoseRate


class XSDataAtom(XSData):
    subclass = None
    def __init__(self, concentration=None, numberOf=None, symbol=None):
        XSData.__init__(self)
        self.concentration = concentration
        self.numberOf = numberOf
        self.symbol = symbol
    def factory(*args_, **kwargs_):
        if XSDataAtom.subclass:
            return XSDataAtom.subclass(*args_, **kwargs_)
        else:
            return XSDataAtom(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getConcentration(self): return self.concentration
    def setConcentration(self, concentration): self.concentration = concentration
    def getNumberOf(self): return self.numberOf
    def setNumberOf(self, numberOf): self.numberOf = numberOf
    def getSymbol(self): return self.symbol
    def setSymbol(self, symbol): self.symbol = symbol
    def export(self, outfile, level, name_='XSDataAtom'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataAtom'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataAtom')
    def exportChildren(self, outfile, level, name_='XSDataAtom'):
        if self.concentration:
            self.concentration.export(outfile, level, name_='concentration')
        if self.numberOf:
            self.numberOf.export(outfile, level, name_='numberOf')
        if self.symbol:
            self.symbol.export(outfile, level, name_='symbol')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataAtom' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataAtom.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataAtom.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataAtom" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataAtom'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.concentration:
            showIndent(outfile, level)
            outfile.write('concentration=XSDataFloat(\n')
            self.concentration.exportLiteral(outfile, level, name_='concentration')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.numberOf:
            showIndent(outfile, level)
            outfile.write('numberOf=XSDataInteger(\n')
            self.numberOf.exportLiteral(outfile, level, name_='numberOf')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.symbol:
            showIndent(outfile, level)
            outfile.write('symbol=XSDataString(\n')
            self.symbol.exportLiteral(outfile, level, name_='symbol')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'concentration':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setConcentration(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'numberOf':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumberOf(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'symbol':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setSymbol(obj_)
# end class XSDataAtom


class XSDataSpaceGroup(XSData):
    subclass = None
    def __init__(self, ITNumber=None, name=None):
        XSData.__init__(self)
        self.ITNumber = ITNumber
        self.name = name
    def factory(*args_, **kwargs_):
        if XSDataSpaceGroup.subclass:
            return XSDataSpaceGroup.subclass(*args_, **kwargs_)
        else:
            return XSDataSpaceGroup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getITNumber(self): return self.ITNumber
    def setITNumber(self, ITNumber): self.ITNumber = ITNumber
    def getName(self): return self.name
    def setName(self, name): self.name = name
    def export(self, outfile, level, name_='XSDataSpaceGroup'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSpaceGroup'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSpaceGroup')
    def exportChildren(self, outfile, level, name_='XSDataSpaceGroup'):
        if self.ITNumber:
            self.ITNumber.export(outfile, level, name_='ITNumber')
        if self.name:
            self.name.export(outfile, level, name_='name')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSpaceGroup' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSpaceGroup.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSpaceGroup.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSpaceGroup" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSpaceGroup'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ITNumber:
            showIndent(outfile, level)
            outfile.write('ITNumber=XSDataInteger(\n')
            self.ITNumber.exportLiteral(outfile, level, name_='ITNumber')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.name:
            showIndent(outfile, level)
            outfile.write('name=XSDataString(\n')
            self.name.exportLiteral(outfile, level, name_='name')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ITNumber':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setITNumber(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setName(obj_)
# end class XSDataSpaceGroup


class XSDataCrystal(XSData):
    subclass = None
    def __init__(self, cell=None, mosaicity=None, spaceGroup=None):
        XSData.__init__(self)
        self.cell = cell
        self.mosaicity = mosaicity
        self.spaceGroup = spaceGroup
    def factory(*args_, **kwargs_):
        if XSDataCrystal.subclass:
            return XSDataCrystal.subclass(*args_, **kwargs_)
        else:
            return XSDataCrystal(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCell(self): return self.cell
    def setCell(self, cell): self.cell = cell
    def getMosaicity(self): return self.mosaicity
    def setMosaicity(self, mosaicity): self.mosaicity = mosaicity
    def getSpaceGroup(self): return self.spaceGroup
    def setSpaceGroup(self, spaceGroup): self.spaceGroup = spaceGroup
    def export(self, outfile, level, name_='XSDataCrystal'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataCrystal'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataCrystal')
    def exportChildren(self, outfile, level, name_='XSDataCrystal'):
        if self.cell:
            self.cell.export(outfile, level, name_='cell')
        if self.mosaicity:
            self.mosaicity.export(outfile, level, name_='mosaicity')
        if self.spaceGroup:
            self.spaceGroup.export(outfile, level, name_='spaceGroup')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataCrystal' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataCrystal.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataCrystal.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataCrystal" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataCrystal'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.cell:
            showIndent(outfile, level)
            outfile.write('cell=XSDataCell(\n')
            self.cell.exportLiteral(outfile, level, name_='cell')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.mosaicity:
            showIndent(outfile, level)
            outfile.write('mosaicity=XSDataFloat(\n')
            self.mosaicity.exportLiteral(outfile, level, name_='mosaicity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.spaceGroup:
            showIndent(outfile, level)
            outfile.write('spaceGroup=XSDataSpaceGroup(\n')
            self.spaceGroup.exportLiteral(outfile, level, name_='spaceGroup')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cell':
            obj_ = XSDataCell.factory()
            obj_.build(child_)
            self.setCell(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mosaicity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setMosaicity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spaceGroup':
            obj_ = XSDataSpaceGroup.factory()
            obj_.build(child_)
            self.setSpaceGroup(obj_)
# end class XSDataCrystal


class XSDataAngularSpeed(XSData):
    subclass = None
    def __init__(self, value=0.0):
        XSData.__init__(self)
        self.value = value
    def factory(*args_, **kwargs_):
        if XSDataAngularSpeed.subclass:
            return XSDataAngularSpeed.subclass(*args_, **kwargs_)
        else:
            return XSDataAngularSpeed(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='XSDataAngularSpeed'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataAngularSpeed'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataAngularSpeed')
    def exportChildren(self, outfile, level, name_='XSDataAngularSpeed'):
        showIndent(outfile, level)
        outfile.write('<value>%f</value>\n' % self.getValue())
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataAngularSpeed' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataAngularSpeed.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataAngularSpeed.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataAngularSpeed" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataAngularSpeed'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('value=%f,\n' % self.getValue())
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    fval_ = float(sval_)
                except ValueError:
                    raise ValueError('requires float (or double) -- %s' % child_.toxml())
                self.value = fval_
# end class XSDataAngularSpeed


class XSDataDiffractionPlan(XSData):
    subclass = None
    def __init__(self, aimedCompleteness=None, aimedIOverSigmaAtHighestResolution=None, aimedMultiplicity=None, aimedResolution=None, forcedSpaceGroup=None, maxExposureTimePerDataCollection=None, requiredCompleteness=None, requiredMultiplicity=None, requiredResolution=None):
        XSData.__init__(self)
        self.aimedCompleteness = aimedCompleteness
        self.aimedIOverSigmaAtHighestResolution = aimedIOverSigmaAtHighestResolution
        self.aimedMultiplicity = aimedMultiplicity
        self.aimedResolution = aimedResolution
        self.forcedSpaceGroup = forcedSpaceGroup
        self.maxExposureTimePerDataCollection = maxExposureTimePerDataCollection
        self.requiredCompleteness = requiredCompleteness
        self.requiredMultiplicity = requiredMultiplicity
        self.requiredResolution = requiredResolution
    def factory(*args_, **kwargs_):
        if XSDataDiffractionPlan.subclass:
            return XSDataDiffractionPlan.subclass(*args_, **kwargs_)
        else:
            return XSDataDiffractionPlan(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAimedCompleteness(self): return self.aimedCompleteness
    def setAimedCompleteness(self, aimedCompleteness): self.aimedCompleteness = aimedCompleteness
    def getAimedIOverSigmaAtHighestResolution(self): return self.aimedIOverSigmaAtHighestResolution
    def setAimedIOverSigmaAtHighestResolution(self, aimedIOverSigmaAtHighestResolution): self.aimedIOverSigmaAtHighestResolution = aimedIOverSigmaAtHighestResolution
    def getAimedMultiplicity(self): return self.aimedMultiplicity
    def setAimedMultiplicity(self, aimedMultiplicity): self.aimedMultiplicity = aimedMultiplicity
    def getAimedResolution(self): return self.aimedResolution
    def setAimedResolution(self, aimedResolution): self.aimedResolution = aimedResolution
    def getForcedSpaceGroup(self): return self.forcedSpaceGroup
    def setForcedSpaceGroup(self, forcedSpaceGroup): self.forcedSpaceGroup = forcedSpaceGroup
    def getMaxExposureTimePerDataCollection(self): return self.maxExposureTimePerDataCollection
    def setMaxExposureTimePerDataCollection(self, maxExposureTimePerDataCollection): self.maxExposureTimePerDataCollection = maxExposureTimePerDataCollection
    def getRequiredCompleteness(self): return self.requiredCompleteness
    def setRequiredCompleteness(self, requiredCompleteness): self.requiredCompleteness = requiredCompleteness
    def getRequiredMultiplicity(self): return self.requiredMultiplicity
    def setRequiredMultiplicity(self, requiredMultiplicity): self.requiredMultiplicity = requiredMultiplicity
    def getRequiredResolution(self): return self.requiredResolution
    def setRequiredResolution(self, requiredResolution): self.requiredResolution = requiredResolution
    def export(self, outfile, level, name_='XSDataDiffractionPlan'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataDiffractionPlan'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataDiffractionPlan')
    def exportChildren(self, outfile, level, name_='XSDataDiffractionPlan'):
        if self.aimedCompleteness:
            self.aimedCompleteness.export(outfile, level, name_='aimedCompleteness')
        if self.aimedIOverSigmaAtHighestResolution:
            self.aimedIOverSigmaAtHighestResolution.export(outfile, level, name_='aimedIOverSigmaAtHighestResolution')
        if self.aimedMultiplicity:
            self.aimedMultiplicity.export(outfile, level, name_='aimedMultiplicity')
        if self.aimedResolution:
            self.aimedResolution.export(outfile, level, name_='aimedResolution')
        if self.forcedSpaceGroup:
            self.forcedSpaceGroup.export(outfile, level, name_='forcedSpaceGroup')
        if self.maxExposureTimePerDataCollection:
            self.maxExposureTimePerDataCollection.export(outfile, level, name_='maxExposureTimePerDataCollection')
        if self.requiredCompleteness:
            self.requiredCompleteness.export(outfile, level, name_='requiredCompleteness')
        if self.requiredMultiplicity:
            self.requiredMultiplicity.export(outfile, level, name_='requiredMultiplicity')
        if self.requiredResolution:
            self.requiredResolution.export(outfile, level, name_='requiredResolution')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataDiffractionPlan' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataDiffractionPlan.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataDiffractionPlan.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataDiffractionPlan" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataDiffractionPlan'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.aimedCompleteness:
            showIndent(outfile, level)
            outfile.write('aimedCompleteness=XSDataFloat(\n')
            self.aimedCompleteness.exportLiteral(outfile, level, name_='aimedCompleteness')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.aimedIOverSigmaAtHighestResolution:
            showIndent(outfile, level)
            outfile.write('aimedIOverSigmaAtHighestResolution=XSDataFloat(\n')
            self.aimedIOverSigmaAtHighestResolution.exportLiteral(outfile, level, name_='aimedIOverSigmaAtHighestResolution')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.aimedMultiplicity:
            showIndent(outfile, level)
            outfile.write('aimedMultiplicity=XSDataFloat(\n')
            self.aimedMultiplicity.exportLiteral(outfile, level, name_='aimedMultiplicity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.aimedResolution:
            showIndent(outfile, level)
            outfile.write('aimedResolution=XSDataFloat(\n')
            self.aimedResolution.exportLiteral(outfile, level, name_='aimedResolution')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.forcedSpaceGroup:
            showIndent(outfile, level)
            outfile.write('forcedSpaceGroup=XSDataString(\n')
            self.forcedSpaceGroup.exportLiteral(outfile, level, name_='forcedSpaceGroup')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.maxExposureTimePerDataCollection:
            showIndent(outfile, level)
            outfile.write('maxExposureTimePerDataCollection=XSDataTime(\n')
            self.maxExposureTimePerDataCollection.exportLiteral(outfile, level, name_='maxExposureTimePerDataCollection')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.requiredCompleteness:
            showIndent(outfile, level)
            outfile.write('requiredCompleteness=XSDataFloat(\n')
            self.requiredCompleteness.exportLiteral(outfile, level, name_='requiredCompleteness')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.requiredMultiplicity:
            showIndent(outfile, level)
            outfile.write('requiredMultiplicity=XSDataFloat(\n')
            self.requiredMultiplicity.exportLiteral(outfile, level, name_='requiredMultiplicity')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.requiredResolution:
            showIndent(outfile, level)
            outfile.write('requiredResolution=XSDataFloat(\n')
            self.requiredResolution.exportLiteral(outfile, level, name_='requiredResolution')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aimedCompleteness':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAimedCompleteness(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aimedIOverSigmaAtHighestResolution':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAimedIOverSigmaAtHighestResolution(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aimedMultiplicity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAimedMultiplicity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aimedResolution':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setAimedResolution(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'forcedSpaceGroup':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setForcedSpaceGroup(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maxExposureTimePerDataCollection':
            obj_ = XSDataTime.factory()
            obj_.build(child_)
            self.setMaxExposureTimePerDataCollection(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'requiredCompleteness':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setRequiredCompleteness(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'requiredMultiplicity':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setRequiredMultiplicity(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'requiredResolution':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setRequiredResolution(obj_)
# end class XSDataDiffractionPlan


class XSDataImage(XSDataFile):
    subclass = None
    def __init__(self, date=None, number=None, path=None):
        XSDataFile.__init__(self, path)
        self.date = date
        self.number = number
    def factory(*args_, **kwargs_):
        if XSDataImage.subclass:
            return XSDataImage.subclass(*args_, **kwargs_)
        else:
            return XSDataImage(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDate(self): return self.date
    def setDate(self, date): self.date = date
    def getNumber(self): return self.number
    def setNumber(self, number): self.number = number
    def export(self, outfile, level, name_='XSDataImage'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataImage'):
        XSDataFile.exportAttributes(self, outfile, level, name_='XSDataImage')
    def exportChildren(self, outfile, level, name_='XSDataImage'):
        if self.date:
            self.date.export(outfile, level, name_='date')
        if self.number:
            self.number.export(outfile, level, name_='number')
        XSDataFile.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataImage' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataImage.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataImage.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataImage" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataImage'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataFile.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.date:
            showIndent(outfile, level)
            outfile.write('date=XSDataString(\n')
            self.date.exportLiteral(outfile, level, name_='date')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.number:
            showIndent(outfile, level)
            outfile.write('number=XSDataInteger(\n')
            self.number.exportLiteral(outfile, level, name_='number')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataFile.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataFile.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'date':
            obj_ = XSDataString.factory()
            obj_.build(child_)
            self.setDate(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'number':
            obj_ = XSDataInteger.factory()
            obj_.build(child_)
            self.setNumber(obj_)
        XSDataFile.buildChildren(self, child_, nodeName_)
# end class XSDataImage


class XSDataSample(XSData):
    subclass = None
    def __init__(self, absorbedDoseRate=None, shape=None, size=None, susceptibility=None):
        XSData.__init__(self)
        self.absorbedDoseRate = absorbedDoseRate
        self.shape = shape
        self.size = size
        self.susceptibility = susceptibility
    def factory(*args_, **kwargs_):
        if XSDataSample.subclass:
            return XSDataSample.subclass(*args_, **kwargs_)
        else:
            return XSDataSample(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAbsorbedDoseRate(self): return self.absorbedDoseRate
    def setAbsorbedDoseRate(self, absorbedDoseRate): self.absorbedDoseRate = absorbedDoseRate
    def getShape(self): return self.shape
    def setShape(self, shape): self.shape = shape
    def getSize(self): return self.size
    def setSize(self, size): self.size = size
    def getSusceptibility(self): return self.susceptibility
    def setSusceptibility(self, susceptibility): self.susceptibility = susceptibility
    def export(self, outfile, level, name_='XSDataSample'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSample'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSample')
    def exportChildren(self, outfile, level, name_='XSDataSample'):
        if self.getAbsorbedDoseRate() != None :
            if self.absorbedDoseRate:
                self.absorbedDoseRate.export(outfile, level, name_='absorbedDoseRate')
        if self.getShape() != None :
            if self.shape:
                self.shape.export(outfile, level, name_='shape')
        if self.getSize() != None :
            if self.size:
                self.size.export(outfile, level, name_='size')
        if self.getSusceptibility() != None :
            if self.susceptibility:
                self.susceptibility.export(outfile, level, name_='susceptibility')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSample' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSample.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSample.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSample" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSample'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.absorbedDoseRate:
            showIndent(outfile, level)
            outfile.write('absorbedDoseRate=XSDataAbsorbedDoseRate(\n')
            self.absorbedDoseRate.exportLiteral(outfile, level, name_='absorbedDoseRate')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.shape:
            showIndent(outfile, level)
            outfile.write('shape=XSDataFloat(\n')
            self.shape.exportLiteral(outfile, level, name_='shape')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.size:
            showIndent(outfile, level)
            outfile.write('size=XSDataSize(\n')
            self.size.exportLiteral(outfile, level, name_='size')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.susceptibility:
            showIndent(outfile, level)
            outfile.write('susceptibility=XSDataFloat(\n')
            self.susceptibility.exportLiteral(outfile, level, name_='susceptibility')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'absorbedDoseRate':
            obj_ = XSDataAbsorbedDoseRate.factory()
            obj_.build(child_)
            self.setAbsorbedDoseRate(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shape':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setShape(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'size':
            obj_ = XSDataSize.factory()
            obj_.build(child_)
            self.setSize(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'susceptibility':
            obj_ = XSDataFloat.factory()
            obj_.build(child_)
            self.setSusceptibility(obj_)
# end class XSDataSample


class XSDataCollection(XSData):
    subclass = None
    def __init__(self, diffractionPlan=None, sample=None, subWedge=None):
        XSData.__init__(self)
        self.diffractionPlan = diffractionPlan
        self.sample = sample
        if subWedge is None:
            self.subWedge = []
        else:
            self.subWedge = subWedge
    def factory(*args_, **kwargs_):
        if XSDataCollection.subclass:
            return XSDataCollection.subclass(*args_, **kwargs_)
        else:
            return XSDataCollection(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDiffractionPlan(self): return self.diffractionPlan
    def setDiffractionPlan(self, diffractionPlan): self.diffractionPlan = diffractionPlan
    def getSample(self): return self.sample
    def setSample(self, sample): self.sample = sample
    def getSubWedge(self): return self.subWedge
    def setSubWedge(self, subWedge): self.subWedge = subWedge
    def addSubWedge(self, value): self.subWedge.append(value)
    def insertSubWedge(self, index, value): self.subWedge[index] = value
    def export(self, outfile, level, name_='XSDataCollection'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataCollection'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataCollection')
    def exportChildren(self, outfile, level, name_='XSDataCollection'):
        if self.diffractionPlan:
            self.diffractionPlan.export(outfile, level, name_='diffractionPlan')
        if self.sample:
            self.sample.export(outfile, level, name_='sample')
        for subWedge_ in self.getSubWedge():
            subWedge_.export(outfile, level, name_='subWedge')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataCollection' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataCollection.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataCollection.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataCollection" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataCollection'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.diffractionPlan:
            showIndent(outfile, level)
            outfile.write('diffractionPlan=XSDataDiffractionPlan(\n')
            self.diffractionPlan.exportLiteral(outfile, level, name_='diffractionPlan')
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.sample:
            showIndent(outfile, level)
            outfile.write('sample=XSDataSampleCrystalMM(\n')
            self.sample.exportLiteral(outfile, level, name_='sample')
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('subWedge=[\n')
        level += 1
        for subWedge in self.subWedge:
            showIndent(outfile, level)
            outfile.write('XSDataSubWedge(\n')
            subWedge.exportLiteral(outfile, level, name_='subWedge')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'diffractionPlan':
            obj_ = XSDataDiffractionPlan.factory()
            obj_.build(child_)
            self.setDiffractionPlan(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sample':
            obj_ = XSDataSampleCrystalMM.factory()
            obj_.build(child_)
            self.setSample(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subWedge':
            obj_ = XSDataSubWedge.factory()
            obj_.build(child_)
            self.subWedge.append(obj_)
# end class XSDataCollection


class XSDataSubWedge(XSData):
    subclass = None
    def __init__(self, experimentalCondition=None, image=None):
        XSData.__init__(self)
        self.experimentalCondition = experimentalCondition
        if image is None:
            self.image = []
        else:
            self.image = image
    def factory(*args_, **kwargs_):
        if XSDataSubWedge.subclass:
            return XSDataSubWedge.subclass(*args_, **kwargs_)
        else:
            return XSDataSubWedge(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getExperimentalCondition(self): return self.experimentalCondition
    def setExperimentalCondition(self, experimentalCondition): self.experimentalCondition = experimentalCondition
    def getImage(self): return self.image
    def setImage(self, image): self.image = image
    def addImage(self, value): self.image.append(value)
    def insertImage(self, index, value): self.image[index] = value
    def export(self, outfile, level, name_='XSDataSubWedge'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSubWedge'):
        XSData.exportAttributes(self, outfile, level, name_='XSDataSubWedge')
    def exportChildren(self, outfile, level, name_='XSDataSubWedge'):
        if self.experimentalCondition:
            self.experimentalCondition.export(outfile, level, name_='experimentalCondition')
        for image_ in self.getImage():
            image_.export(outfile, level, name_='image')
        XSData.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSubWedge' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSubWedge.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSubWedge.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSubWedge" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSubWedge'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSData.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.experimentalCondition:
            showIndent(outfile, level)
            outfile.write('experimentalCondition=XSDataExperimentalCondition(\n')
            self.experimentalCondition.exportLiteral(outfile, level, name_='experimentalCondition')
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('image=[\n')
        level += 1
        for image in self.image:
            showIndent(outfile, level)
            outfile.write('XSDataImage(\n')
            image.exportLiteral(outfile, level, name_='image')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        XSData.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSData.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'experimentalCondition':
            obj_ = XSDataExperimentalCondition.factory()
            obj_.build(child_)
            self.setExperimentalCondition(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'image':
            obj_ = XSDataImage.factory()
            obj_.build(child_)
            self.image.append(obj_)
# end class XSDataSubWedge


class XSDataSampleCrystal(XSDataSample):
    subclass = None
    def __init__(self, crystal=None, absorbedDoseRate=None, shape=None, size=None, susceptibility=None):
        XSDataSample.__init__(self, absorbedDoseRate, shape, size, susceptibility)
        self.crystal = crystal
    def factory(*args_, **kwargs_):
        if XSDataSampleCrystal.subclass:
            return XSDataSampleCrystal.subclass(*args_, **kwargs_)
        else:
            return XSDataSampleCrystal(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCrystal(self): return self.crystal
    def setCrystal(self, crystal): self.crystal = crystal
    def export(self, outfile, level, name_='XSDataSampleCrystal'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSampleCrystal'):
        XSDataSample.exportAttributes(self, outfile, level, name_='XSDataSampleCrystal')
    def exportChildren(self, outfile, level, name_='XSDataSampleCrystal'):
        if self.crystal:
            self.crystal.export(outfile, level, name_='crystal')
        XSDataSample.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSampleCrystal' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSampleCrystal.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSampleCrystal.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSampleCrystal" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSampleCrystal'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataSample.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.crystal:
            showIndent(outfile, level)
            outfile.write('crystal=XSDataCrystal(\n')
            self.crystal.exportLiteral(outfile, level, name_='crystal')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataSample.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataSample.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'crystal':
            obj_ = XSDataCrystal.factory()
            obj_.build(child_)
            self.setCrystal(obj_)
        XSDataSample.buildChildren(self, child_, nodeName_)
# end class XSDataSampleCrystal


class XSDataSampleCrystalMM(XSDataSampleCrystal):
    subclass = None
    def __init__(self, chemicalComposition=None, crystal=None, absorbedDoseRate=None, shape=None, size=None, susceptibility=None):
        XSDataSampleCrystal.__init__(self, crystal, absorbedDoseRate, shape, size, susceptibility)
        self.chemicalComposition = chemicalComposition
    def factory(*args_, **kwargs_):
        if XSDataSampleCrystalMM.subclass:
            return XSDataSampleCrystalMM.subclass(*args_, **kwargs_)
        else:
            return XSDataSampleCrystalMM(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getChemicalComposition(self): return self.chemicalComposition
    def setChemicalComposition(self, chemicalComposition): self.chemicalComposition = chemicalComposition
    def export(self, outfile, level, name_='XSDataSampleCrystalMM'):
        showIndent(outfile, level)
        outfile.write('<%s>\n' % name_)
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='XSDataSampleCrystalMM'):
        XSDataSampleCrystal.exportAttributes(self, outfile, level, name_='XSDataSampleCrystalMM')
    def exportChildren(self, outfile, level, name_='XSDataSampleCrystalMM'):
        if self.getChemicalComposition() != None :
            if self.chemicalComposition:
                self.chemicalComposition.export(outfile, level, name_='chemicalComposition')
        XSDataSampleCrystal.exportChildren(self, outfile, level, name_)

    #Only to export the entire XML tree to a file stream on disk
    def outputFile( self, _outfileName ):
        outfile = open( _outfileName, "w" )
        outfile.write("<?xml version=\"1.0\" ?>\n")
        self.export( outfile, 0, name_='XSDataSampleCrystalMM' )
        outfile.close()


    #Static method for parsing a string
    def parseString( _inString ):
        doc = minidom.parseString(_inString)
        rootNode = doc.documentElement
        rootObj = XSDataSampleCrystalMM.factory()
        rootObj.build(rootNode)
        return rootObj
    parseString = staticmethod( parseString ) 


    #Static method for parsing a file
    def parseFile( _inFilePath ):
        doc = minidom.parse(_inFilePath)
        rootNode = doc.documentElement
        rootObj = XSDataSampleCrystalMM.factory()
        rootObj.build(rootNode)
        return rootObj
    parseFile = staticmethod( parseFile ) 


    #Method for marshalling an object
    def marshal( self ):
        oStreamString = StringIO.StringIO()
        oStreamString.write('<?xml version="1.0" ?>\n')
        self.export( oStreamString, 0, name_="XSDataSampleCrystalMM" )
        oStringXML = oStreamString.getvalue()
        oStreamString.close()
        return oStringXML

    def exportLiteral(self, outfile, level, name_='XSDataSampleCrystalMM'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        XSDataSampleCrystal.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        if self.chemicalComposition:
            showIndent(outfile, level)
            outfile.write('chemicalComposition=XSDataChemicalCompositionMM(\n')
            self.chemicalComposition.exportLiteral(outfile, level, name_='chemicalComposition')
            showIndent(outfile, level)
            outfile.write('),\n')
        XSDataSampleCrystal.exportLiteralChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        XSDataSampleCrystal.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'chemicalComposition':
            obj_ = XSDataChemicalCompositionMM.factory()
            obj_.build(child_)
            self.setChemicalComposition(obj_)
        XSDataSampleCrystal.buildChildren(self, child_, nodeName_)
# end class XSDataSampleCrystalMM


from xml.sax import handler, make_parser

class SaxStackElement:
    def __init__(self, name='', obj=None):
        self.name = name
        self.obj = obj
        self.content = ''

#
# SAX handler
#
class SaxXSDataSubWedgeHandler(handler.ContentHandler):
    def __init__(self):
        self.stack = []
        self.root = None

    def getRoot(self):
        return self.root

    def setDocumentLocator(self, locator):
        self.locator = locator
    
    def showError(self, msg):
        print '*** (showError):', msg
        sys.exit(-1)

    def startElement(self, name, attrs):
        done = 0
        if name == 'XSDataSubWedge':
            obj = XSDataSubWedge.factory()
            stackObj = SaxStackElement('XSDataSubWedge', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'experimentalCondition':
            obj = XSDataExperimentalCondition.factory()
            stackObj = SaxStackElement('experimentalCondition', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'image':
            obj = XSDataImage.factory()
            stackObj = SaxStackElement('image', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'diffractionPlan':
            obj = XSDataDiffractionPlan.factory()
            stackObj = SaxStackElement('diffractionPlan', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sample':
            obj = XSDataSampleCrystalMM.factory()
            stackObj = SaxStackElement('sample', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'subWedge':
            obj = XSDataSubWedge.factory()
            stackObj = SaxStackElement('subWedge', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'absorbedDoseRate':
            obj = XSDataAbsorbedDoseRate.factory()
            stackObj = SaxStackElement('absorbedDoseRate', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'shape':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('shape', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'size':
            obj = XSDataSize.factory()
            stackObj = SaxStackElement('size', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'susceptibility':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('susceptibility', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'date':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('date', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'number':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('number', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'chemicalComposition':
            obj = XSDataChemicalCompositionMM.factory()
            stackObj = SaxStackElement('chemicalComposition', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'crystal':
            obj = XSDataCrystal.factory()
            stackObj = SaxStackElement('crystal', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'aimedCompleteness':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('aimedCompleteness', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'aimedIOverSigmaAtHighestResolution':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('aimedIOverSigmaAtHighestResolution', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'aimedMultiplicity':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('aimedMultiplicity', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'aimedResolution':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('aimedResolution', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'forcedSpaceGroup':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('forcedSpaceGroup', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'maxExposureTimePerDataCollection':
            obj = XSDataTime.factory()
            stackObj = SaxStackElement('maxExposureTimePerDataCollection', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'requiredCompleteness':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('requiredCompleteness', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'requiredMultiplicity':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('requiredMultiplicity', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'requiredResolution':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('requiredResolution', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'value':
            stackObj = SaxStackElement('value', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'cell':
            obj = XSDataCell.factory()
            stackObj = SaxStackElement('cell', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'mosaicity':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('mosaicity', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'spaceGroup':
            obj = XSDataSpaceGroup.factory()
            stackObj = SaxStackElement('spaceGroup', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'ITNumber':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('ITNumber', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'name':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('name', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'concentration':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('concentration', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOf':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOf', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'symbol':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('symbol', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'path':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('path', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'exposureTime':
            obj = XSDataTime.factory()
            stackObj = SaxStackElement('exposureTime', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'flux':
            obj = XSDataFlux.factory()
            stackObj = SaxStackElement('flux', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'minExposureTimePerImage':
            obj = XSDataTime.factory()
            stackObj = SaxStackElement('minExposureTimePerImage', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'wavelength':
            obj = XSDataWavelength.factory()
            stackObj = SaxStackElement('wavelength', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'beam':
            obj = XSDataBeam.factory()
            stackObj = SaxStackElement('beam', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'detector':
            obj = XSDataDetector.factory()
            stackObj = SaxStackElement('detector', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'goniostat':
            obj = XSDataGoniostat.factory()
            stackObj = SaxStackElement('goniostat', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'chain':
            obj = XSDataChain.factory()
            stackObj = SaxStackElement('chain', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'ligand':
            obj = XSDataLigand.factory()
            stackObj = SaxStackElement('ligand', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfCopiesInAsymmetricUnit':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('numberOfCopiesInAsymmetricUnit', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'x':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('x', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'y':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('y', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'z':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('z', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'beamPositionX':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('beamPositionX', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'beamPositionY':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('beamPositionY', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'bin':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('bin', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'byteOrder':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('byteOrder', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'dataType':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('dataType', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'distance':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('distance', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'gain':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('gain', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'imageSaturation':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('imageSaturation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberBytesInHeader':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberBytesInHeader', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberPixelX':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberPixelX', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberPixelY':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberPixelY', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'pixelSizeX':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('pixelSizeX', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'pixelSizeY':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('pixelSizeY', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'serialNumber':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('serialNumber', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'twoTheta':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('twoTheta', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'type':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('typexx', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'maxOscillationSpeed':
            obj = XSDataAngularSpeed.factory()
            stackObj = SaxStackElement('maxOscillationSpeed', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'minOscillationWidth':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('minOscillationWidth', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'oscillationWidth':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('oscillationWidth', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'rotationAxis':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('rotationAxis', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'rotationAxisEnd':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('rotationAxisEnd', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'rotationAxisStart':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('rotationAxisStart', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'heavyAtoms':
            obj = XSDataAtomicComposition.factory()
            stackObj = SaxStackElement('heavyAtoms', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfCopies':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('numberOfCopies', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfMonomers':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('numberOfMonomers', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'angle_alpha':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('angle_alpha', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'angle_beta':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('angle_beta', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'angle_gamma':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('angle_gamma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'length_a':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('length_a', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'length_b':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('length_b', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'length_c':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('length_c', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfLightAtoms':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('numberOfLightAtoms', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'atoms':
            obj = XSDataAtomicComposition.factory()
            stackObj = SaxStackElement('atoms', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm11':
            stackObj = SaxStackElement('m11', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm12':
            stackObj = SaxStackElement('m12', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm13':
            stackObj = SaxStackElement('m13', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm21':
            stackObj = SaxStackElement('m21', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm22':
            stackObj = SaxStackElement('m22', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm23':
            stackObj = SaxStackElement('m23', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm31':
            stackObj = SaxStackElement('m31', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm32':
            stackObj = SaxStackElement('m32', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'm33':
            stackObj = SaxStackElement('m33', None)
            self.stack.append(stackObj)
            done = 1
        elif name == 'atom':
            obj = XSDataAtom.factory()
            stackObj = SaxStackElement('atom', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'solvent':
            obj = XSDataSolvent.factory()
            stackObj = SaxStackElement('solvent', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'structure':
            obj = XSDataStructure.factory()
            stackObj = SaxStackElement('structure', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'beamShift':
            obj = XSDataMOSFLMBeamPosition.factory()
            stackObj = SaxStackElement('beamShift', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'deviationAngular':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('deviationAngular', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'deviationPositional':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('deviationPositional', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'mosaicityEstimation':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('mosaicityEstimation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'possibleSolutions':
            obj = XSDataMOSFLMIndexingSolution.factory()
            stackObj = SaxStackElement('possibleSolutions', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'selectedSolutionNumber':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('selectedSolutionNumber', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'selectedSolutionSpaceGroup':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('selectedSolutionSpaceGroup', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'selectedSolutionSpaceGroupNumber':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('selectedSolutionSpaceGroupNumber', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'spotsTotal':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('spotsTotal', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'spotsUsed':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('spotsUsed', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'predictionImage':
            obj = XSDataImage.factory()
            stackObj = SaxStackElement('predictionImage', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'averageIntensity':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('averageIntensity', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'averageIOverSigma':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('averageIOverSigma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'averageSigma':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('averageSigma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'phix':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('phix', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'phiy':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('phiy', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'phiz':
            obj = XSDataAngle.factory()
            stackObj = SaxStackElement('phiz', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'bestfileDat':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('bestfileDat', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'bestfileHKL':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('bestfileHKL', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'bestfilePar':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('bestfilePar', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'generatedMTZFile':
            obj = XSDataFile.factory()
            stackObj = SaxStackElement('generatedMTZFile', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'highestResolutionIOverSigma':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('highestResolutionIOverSigma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfBadReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfBadReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfFullyRecordedReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfFullyRecordedReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfNegativeReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfNegativeReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfOverlappedReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfOverlappedReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfPartialReflections':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfPartialReflections', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'numberOfReflectionsGenerated':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('numberOfReflectionsGenerated', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'overallIOverSigma':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('overallIOverSigma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'overallStatistics':
            obj = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
            stackObj = SaxStackElement('overallStatistics', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedMosaicity':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('refinedMosaicity', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedYScale':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('refinedYScale', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'RMSSpotDeviation':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('RMSSpotDeviation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'statisticsPerResolutionBin':
            obj = XSDataMOSFLMIntegrationStatisticsPerResolutionBin.factory()
            stackObj = SaxStackElement('statisticsPerResolutionBin', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedBeam':
            obj = XSDataMOSFLMBeamPosition.factory()
            stackObj = SaxStackElement('refinedBeam', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedDistance':
            obj = XSDataLength.factory()
            stackObj = SaxStackElement('refinedDistance', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedNewmat':
            obj = XSDataMOSFLMNewmat.factory()
            stackObj = SaxStackElement('refinedNewmat', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'aMatrix':
            obj = XSDataMatrix.factory()
            stackObj = SaxStackElement('aMatrix', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'missettingAngles':
            obj = XSDataMOSFLMMissettingsAngles.factory()
            stackObj = SaxStackElement('missettingAngles', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'refinedCell':
            obj = XSDataCell.factory()
            stackObj = SaxStackElement('refinedCell', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'uMatrix':
            obj = XSDataMatrix.factory()
            stackObj = SaxStackElement('uMatrix', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'maxResolution':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('maxResolution', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'minResolution':
            obj = XSDataFloat.factory()
            stackObj = SaxStackElement('minResolution', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'profileFitted':
            obj = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
            stackObj = SaxStackElement('profileFitted', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'summation':
            obj = XSDataMOSFLMIntegrationStatisticsPerReflectionType.factory()
            stackObj = SaxStackElement('summation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'imageEnd':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('imageEnd', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'imageStart':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('imageStart', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'directory':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('directory', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'matrix':
            obj = XSDataMOSFLMNewmat.factory()
            stackObj = SaxStackElement('matrix', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'symmetry':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('symmetry', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'template':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('template', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'index':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('index', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'lattice':
            obj = XSDataString.factory()
            stackObj = SaxStackElement('lattice', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'penalty':
            obj = XSDataInteger.factory()
            stackObj = SaxStackElement('penalty', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'fullyRecorded':
            obj = XSDataMOSFLMIntegrationStatistics.factory()
            stackObj = SaxStackElement('fullyRecorded', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'partials':
            obj = XSDataMOSFLMIntegrationStatistics.factory()
            stackObj = SaxStackElement('partials', obj)
            self.stack.append(stackObj)
            done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def endElement(self, name):
        done = 0
        if name == 'XSDataSubWedge':
            if len(self.stack) == 1:
                self.root = self.stack[-1].obj
                self.stack.pop()
                done = 1
        elif name == 'experimentalCondition':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setExperimentalCondition(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'image':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addImage(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'diffractionPlan':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDiffractionPlan(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sample':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSample(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'subWedge':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addSubWedge(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'absorbedDoseRate':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAbsorbedDoseRate(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'shape':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setShape(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'size':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSize(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'susceptibility':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSusceptibility(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'date':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDate(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'number':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumber(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'chemicalComposition':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setChemicalComposition(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'crystal':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setCrystal(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'aimedCompleteness':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAimedCompleteness(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'aimedIOverSigmaAtHighestResolution':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAimedIOverSigmaAtHighestResolution(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'aimedMultiplicity':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAimedMultiplicity(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'aimedResolution':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAimedResolution(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'forcedSpaceGroup':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setForcedSpaceGroup(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'maxExposureTimePerDataCollection':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMaxExposureTimePerDataCollection(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'requiredCompleteness':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRequiredCompleteness(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'requiredMultiplicity':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRequiredMultiplicity(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'requiredResolution':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRequiredResolution(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'value':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"value" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setValue(content)
                self.stack.pop()
                done = 1
        elif name == 'cell':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setCell(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'mosaicity':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMosaicity(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'spaceGroup':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSpaceGroup(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'ITNumber':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setITNumber(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'name':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setName(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'concentration':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setConcentration(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOf':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOf(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'symbol':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSymbol(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'path':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPath(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'exposureTime':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setExposureTime(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'flux':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setFlux(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'minExposureTimePerImage':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMinExposureTimePerImage(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'wavelength':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setWavelength(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'beam':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBeam(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'detector':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDetector(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'goniostat':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setGoniostat(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'chain':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addChain(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'ligand':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addLigand(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfCopiesInAsymmetricUnit':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfCopiesInAsymmetricUnit(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'x':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setX(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'y':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setY(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'z':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setZ(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'beamPositionX':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBeamPositionX(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'beamPositionY':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBeamPositionY(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'bin':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBin(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'byteOrder':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setByteOrder(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'dataType':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDataType(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'distance':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDistance(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'gain':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setGain(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'imageSaturation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setImageSaturation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberBytesInHeader':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberBytesInHeader(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberPixelX':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberPixelX(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberPixelY':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberPixelY(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'pixelSizeX':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPixelSizeX(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'pixelSizeY':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPixelSizeY(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'serialNumber':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSerialNumber(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'twoTheta':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setTwoTheta(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'type':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setType(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'maxOscillationSpeed':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMaxOscillationSpeed(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'minOscillationWidth':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMinOscillationWidth(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'oscillationWidth':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setOscillationWidth(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'rotationAxis':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRotationAxis(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'rotationAxisEnd':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRotationAxisEnd(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'rotationAxisStart':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRotationAxisStart(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'heavyAtoms':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setHeavyAtoms(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfCopies':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfCopies(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfMonomers':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfMonomers(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'angle_alpha':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAngle_alpha(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'angle_beta':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAngle_beta(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'angle_gamma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAngle_gamma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'length_a':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setLength_a(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'length_b':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setLength_b(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'length_c':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setLength_c(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfLightAtoms':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfLightAtoms(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'atoms':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAtoms(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'm11':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m11" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM11(content)
                self.stack.pop()
                done = 1
        elif name == 'm12':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m12" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM12(content)
                self.stack.pop()
                done = 1
        elif name == 'm13':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m13" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM13(content)
                self.stack.pop()
                done = 1
        elif name == 'm21':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m21" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM21(content)
                self.stack.pop()
                done = 1
        elif name == 'm22':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m22" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM22(content)
                self.stack.pop()
                done = 1
        elif name == 'm23':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m23" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM23(content)
                self.stack.pop()
                done = 1
        elif name == 'm31':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m31" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM31(content)
                self.stack.pop()
                done = 1
        elif name == 'm32':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m32" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM32(content)
                self.stack.pop()
                done = 1
        elif name == 'm33':
            if len(self.stack) >= 2:
                content = self.stack[-1].content
                if content:
                    try:
                        content = float(content)
                    except:
                        self.reportError('"m33" must be float -- content: %s' % content)
                else:
                    content = -1
                self.stack[-2].obj.setM33(content)
                self.stack.pop()
                done = 1
        elif name == 'atom':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addAtom(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'solvent':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSolvent(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'structure':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setStructure(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'beamShift':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBeamShift(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'deviationAngular':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDeviationAngular(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'deviationPositional':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDeviationPositional(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'mosaicityEstimation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMosaicityEstimation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'possibleSolutions':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addPossibleSolutions(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'selectedSolutionNumber':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSelectedSolutionNumber(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'selectedSolutionSpaceGroup':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSelectedSolutionSpaceGroup(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'selectedSolutionSpaceGroupNumber':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSelectedSolutionSpaceGroupNumber(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'spotsTotal':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSpotsTotal(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'spotsUsed':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSpotsUsed(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'predictionImage':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPredictionImage(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'averageIntensity':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAverageIntensity(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'averageIOverSigma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAverageIOverSigma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'averageSigma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAverageSigma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'phix':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPhix(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'phiy':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPhiy(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'phiz':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPhiz(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'bestfileDat':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBestfileDat(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'bestfileHKL':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBestfileHKL(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'bestfilePar':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setBestfilePar(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'generatedMTZFile':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setGeneratedMTZFile(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'highestResolutionIOverSigma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setHighestResolutionIOverSigma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfBadReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfBadReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfFullyRecordedReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfFullyRecordedReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfNegativeReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfNegativeReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfOverlappedReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfOverlappedReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfPartialReflections':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfPartialReflections(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'numberOfReflectionsGenerated':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setNumberOfReflectionsGenerated(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'overallIOverSigma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setOverallIOverSigma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'overallStatistics':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setOverallStatistics(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedMosaicity':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedMosaicity(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedYScale':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedYScale(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'RMSSpotDeviation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRMSSpotDeviation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'statisticsPerResolutionBin':
            if len(self.stack) >= 2:
                self.stack[-2].obj.addStatisticsPerResolutionBin(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedBeam':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedBeam(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedDistance':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedDistance(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedNewmat':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedNewmat(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'aMatrix':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setAMatrix(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'missettingAngles':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMissettingAngles(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'refinedCell':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setRefinedCell(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'uMatrix':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setUMatrix(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'maxResolution':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMaxResolution(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'minResolution':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMinResolution(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'profileFitted':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setProfileFitted(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'summation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSummation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'imageEnd':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setImageEnd(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'imageStart':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setImageStart(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'directory':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setDirectory(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'matrix':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setMatrix(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'symmetry':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setSymmetry(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'template':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setTemplate(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'index':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setIndex(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'lattice':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setLattice(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'penalty':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPenalty(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'fullyRecorded':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setFullyRecorded(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'partials':
            if len(self.stack) >= 2:
                self.stack[-2].obj.setPartials(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def characters(self, chrs, start, end):
        if len(self.stack) > 0:
            self.stack[-1].content += chrs[start:end]

    def reportError(self, mesg):
        locator = self.locator
        sys.stderr.write('Doc: %s  Line: %d  Column: %d\n' % \
            (locator.getSystemId(), locator.getLineNumber(), 
            locator.getColumnNumber() + 1))
        sys.stderr.write(mesg)
        sys.stderr.write('\n')
        sys.exit(-1)
        #raise RuntimeError

USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
Options:
    -s        Use the SAX parser, not the minidom parser.
"""

def usage():
    print USAGE_TEXT
    sys.exit(-1)


#
# SAX handler used to determine the top level element.
#
class SaxSelectorHandler(handler.ContentHandler):
    def __init__(self):
        self.topElementName = None
    def getTopElementName(self):
        return self.topElementName
    def startElement(self, name, attrs):
        self.topElementName = name
        raise StopIteration


def parseSelect(inFileName):
    infile = file(inFileName, 'r')
    topElementName = None
    parser = make_parser()
    documentHandler = SaxSelectorHandler()
    parser.setContentHandler(documentHandler)
    try:
        try:
            parser.parse(infile)
        except StopIteration:
            topElementName = documentHandler.getTopElementName()
        if topElementName is None:
            raise RuntimeError, 'no top level element'
        topElementName = topElementName.replace('-', '_').replace(':', '_')
        if topElementName not in globals():
            raise RuntimeError, 'no class for top element: %s' % topElementName
        topElement = globals()[topElementName]
        infile.seek(0)
        doc = minidom.parse(infile)
    finally:
        infile.close()
    rootNode = doc.childNodes[0]
    rootObj = topElement.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0)
    return rootObj


def saxParse(inFileName):
    parser = make_parser()
    documentHandler = SaxXSDataSubWedgeHandler()
    parser.setDocumentHandler(documentHandler)
    parser.parse('file:%s' % inFileName)
    root = documentHandler.getRoot()
    sys.stdout.write('<?xml version="1.0" ?>\n')
    root.export(sys.stdout, 0)
    return root


def saxParseString(inString):
    parser = make_parser()
    documentHandler = SaxXSDataSubWedgeHandler()
    parser.setDocumentHandler(documentHandler)
    parser.feed(inString)
    parser.close()
    rootObj = documentHandler.getRoot()
    #sys.stdout.write('<?xml version="1.0" ?>\n')
    #rootObj.export(sys.stdout, 0)
    return rootObj


def parse(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = XSDataSubWedge.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0, name_="XSDataSubWedge")
    return rootObj


def parseString(inString):
    doc = minidom.parseString(inString)
    rootNode = doc.documentElement
    rootObj = XSDataSubWedge.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('<?xml version="1.0" ?>\n')
    rootObj.export(sys.stdout, 0, name_="XSDataSubWedge")
    return rootObj


def parseLiteral(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = XSDataSubWedge.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('from XSDataMOSFLMv01 import *\n\n')
    sys.stdout.write('rootObj = XSDataSubWedge(\n')
    rootObj.exportLiteral(sys.stdout, 0, name_="XSDataSubWedge")
    sys.stdout.write(')\n')
    return rootObj

class XSDataMOSFLMv01:
    pass


def main():
    args = sys.argv[1:]
    if len(args) == 2 and args[0] == '-s':
        saxParse(args[1])
    elif len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    main()
    #import pdb
    #pdb.run('main()')

